#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    _reserved0: [u8; 0x03],
    #[doc = "0x03 - soso"]
    pub r8_eth_eie: R8_ETH_EIE,
    #[doc = "0x04 - soso"]
    pub r8_eth_eir: R8_ETH_EIR,
    #[doc = "0x05 - soso"]
    pub r8_eth_estat: R8_ETH_ESTAT,
    #[doc = "0x06 - soso"]
    pub r8_eth_econ2: R8_ETH_ECON2,
    #[doc = "0x07 - soso"]
    pub r8_eth_econ1: R8_ETH_ECON1,
    #[doc = "0x08 - soso"]
    pub r16_eth_etxst: R16_ETH_ETXST,
    #[doc = "0x0a - soso"]
    pub r16_eth_etxln: R16_ETH_ETXLN,
    #[doc = "0x0c - soso"]
    pub r16_eth_erxst: R16_ETH_ERXST,
    #[doc = "0x0e - soso"]
    pub r16_eth_erxln: R16_ETH_ERXLN,
    #[doc = "0x10 - soso"]
    pub r8_eth_eht0: R8_ETH_EHT0,
    #[doc = "0x11 - soso"]
    pub r8_eth_eht1: R8_ETH_EHT1,
    #[doc = "0x12 - soso"]
    pub r8_eth_eht2: R8_ETH_EHT2,
    #[doc = "0x13 - soso"]
    pub r8_eth_eht3: R8_ETH_EHT3,
    #[doc = "0x14 - soso"]
    pub r8_eth_eht4: R8_ETH_EHT4,
    #[doc = "0x15 - soso"]
    pub r8_eth_eht5: R8_ETH_EHT5,
    #[doc = "0x16 - soso"]
    pub r8_eth_eht6: R8_ETH_EHT6,
    #[doc = "0x17 - soso"]
    pub r8_eth_eht7: R8_ETH_EHT7,
    #[doc = "0x18 - soso"]
    pub r8_eth_erxfcon: R8_ETH_ERXFCON,
    #[doc = "0x19 - soso"]
    pub r8_eth_macon1: R8_ETH_MACON1,
    #[doc = "0x1a - soso"]
    pub r8_eth_macon2: R8_ETH_MACON2,
    #[doc = "0x1b - soso"]
    pub r8_eth_mabbipg: R8_ETH_MABBIPG,
    #[doc = "0x1c - soso"]
    pub r16_eth_epaus: R16_ETH_EPAUS,
    #[doc = "0x1e - soso"]
    pub r16_eth_mamxfl: R16_ETH_MAMXFL,
    #[doc = "0x20 - soso"]
    pub r16_eth_mird: R16_ETH_MIRD,
    _reserved24: [u8; 0x02],
    #[doc = "0x24 - soso"]
    pub r8_eth_miregadr: R8_ETH_MIREGADR,
    #[doc = "0x25 - soso"]
    pub r8_eth_mistat: R8_ETH_MISTAT,
    #[doc = "0x26 - soso"]
    pub r16_eth_miwr: R16_ETH_MIWR,
    #[doc = "0x28 - soso"]
    pub r32_eth_maadrl: R32_ETH_MAADRL,
    #[doc = "0x2c - soso"]
    pub r16_eth_maadrh: R16_ETH_MAADRH,
}
#[doc = "R8_ETH_EIE (rw) register accessor: an alias for `Reg<R8_ETH_EIE_SPEC>`"]
pub type R8_ETH_EIE = crate::Reg<r8_eth_eie::R8_ETH_EIE_SPEC>;
#[doc = "soso"]
pub mod r8_eth_eie;
#[doc = "R8_ETH_EIR (rw) register accessor: an alias for `Reg<R8_ETH_EIR_SPEC>`"]
pub type R8_ETH_EIR = crate::Reg<r8_eth_eir::R8_ETH_EIR_SPEC>;
#[doc = "soso"]
pub mod r8_eth_eir;
#[doc = "R8_ETH_ESTAT (r) register accessor: an alias for `Reg<R8_ETH_ESTAT_SPEC>`"]
pub type R8_ETH_ESTAT = crate::Reg<r8_eth_estat::R8_ETH_ESTAT_SPEC>;
#[doc = "soso"]
pub mod r8_eth_estat;
#[doc = "R8_ETH_ECON2 (rw) register accessor: an alias for `Reg<R8_ETH_ECON2_SPEC>`"]
pub type R8_ETH_ECON2 = crate::Reg<r8_eth_econ2::R8_ETH_ECON2_SPEC>;
#[doc = "soso"]
pub mod r8_eth_econ2;
#[doc = "R8_ETH_ECON1 (rw) register accessor: an alias for `Reg<R8_ETH_ECON1_SPEC>`"]
pub type R8_ETH_ECON1 = crate::Reg<r8_eth_econ1::R8_ETH_ECON1_SPEC>;
#[doc = "soso"]
pub mod r8_eth_econ1;
#[doc = "R16_ETH_ETXST (rw) register accessor: an alias for `Reg<R16_ETH_ETXST_SPEC>`"]
pub type R16_ETH_ETXST = crate::Reg<r16_eth_etxst::R16_ETH_ETXST_SPEC>;
#[doc = "soso"]
pub mod r16_eth_etxst;
#[doc = "R16_ETH_ETXLN (rw) register accessor: an alias for `Reg<R16_ETH_ETXLN_SPEC>`"]
pub type R16_ETH_ETXLN = crate::Reg<r16_eth_etxln::R16_ETH_ETXLN_SPEC>;
#[doc = "soso"]
pub mod r16_eth_etxln;
#[doc = "R16_ETH_ERXST (rw) register accessor: an alias for `Reg<R16_ETH_ERXST_SPEC>`"]
pub type R16_ETH_ERXST = crate::Reg<r16_eth_erxst::R16_ETH_ERXST_SPEC>;
#[doc = "soso"]
pub mod r16_eth_erxst;
#[doc = "R16_ETH_ERXLN (rw) register accessor: an alias for `Reg<R16_ETH_ERXLN_SPEC>`"]
pub type R16_ETH_ERXLN = crate::Reg<r16_eth_erxln::R16_ETH_ERXLN_SPEC>;
#[doc = "soso"]
pub mod r16_eth_erxln;
#[doc = "R8_ETH_EHT0 (rw) register accessor: an alias for `Reg<R8_ETH_EHT0_SPEC>`"]
pub type R8_ETH_EHT0 = crate::Reg<r8_eth_eht0::R8_ETH_EHT0_SPEC>;
#[doc = "soso"]
pub mod r8_eth_eht0;
#[doc = "R8_ETH_EHT1 (rw) register accessor: an alias for `Reg<R8_ETH_EHT1_SPEC>`"]
pub type R8_ETH_EHT1 = crate::Reg<r8_eth_eht1::R8_ETH_EHT1_SPEC>;
#[doc = "soso"]
pub mod r8_eth_eht1;
#[doc = "R8_ETH_EHT2 (rw) register accessor: an alias for `Reg<R8_ETH_EHT2_SPEC>`"]
pub type R8_ETH_EHT2 = crate::Reg<r8_eth_eht2::R8_ETH_EHT2_SPEC>;
#[doc = "soso"]
pub mod r8_eth_eht2;
#[doc = "R8_ETH_EHT3 (rw) register accessor: an alias for `Reg<R8_ETH_EHT3_SPEC>`"]
pub type R8_ETH_EHT3 = crate::Reg<r8_eth_eht3::R8_ETH_EHT3_SPEC>;
#[doc = "soso"]
pub mod r8_eth_eht3;
#[doc = "R8_ETH_EHT4 (rw) register accessor: an alias for `Reg<R8_ETH_EHT4_SPEC>`"]
pub type R8_ETH_EHT4 = crate::Reg<r8_eth_eht4::R8_ETH_EHT4_SPEC>;
#[doc = "soso"]
pub mod r8_eth_eht4;
#[doc = "R8_ETH_EHT5 (rw) register accessor: an alias for `Reg<R8_ETH_EHT5_SPEC>`"]
pub type R8_ETH_EHT5 = crate::Reg<r8_eth_eht5::R8_ETH_EHT5_SPEC>;
#[doc = "soso"]
pub mod r8_eth_eht5;
#[doc = "R8_ETH_EHT6 (rw) register accessor: an alias for `Reg<R8_ETH_EHT6_SPEC>`"]
pub type R8_ETH_EHT6 = crate::Reg<r8_eth_eht6::R8_ETH_EHT6_SPEC>;
#[doc = "soso"]
pub mod r8_eth_eht6;
#[doc = "R8_ETH_EHT7 (rw) register accessor: an alias for `Reg<R8_ETH_EHT7_SPEC>`"]
pub type R8_ETH_EHT7 = crate::Reg<r8_eth_eht7::R8_ETH_EHT7_SPEC>;
#[doc = "soso"]
pub mod r8_eth_eht7;
#[doc = "R8_ETH_ERXFCON (rw) register accessor: an alias for `Reg<R8_ETH_ERXFCON_SPEC>`"]
pub type R8_ETH_ERXFCON = crate::Reg<r8_eth_erxfcon::R8_ETH_ERXFCON_SPEC>;
#[doc = "soso"]
pub mod r8_eth_erxfcon;
#[doc = "R8_ETH_MACON1 (rw) register accessor: an alias for `Reg<R8_ETH_MACON1_SPEC>`"]
pub type R8_ETH_MACON1 = crate::Reg<r8_eth_macon1::R8_ETH_MACON1_SPEC>;
#[doc = "soso"]
pub mod r8_eth_macon1;
#[doc = "R8_ETH_MACON2 (rw) register accessor: an alias for `Reg<R8_ETH_MACON2_SPEC>`"]
pub type R8_ETH_MACON2 = crate::Reg<r8_eth_macon2::R8_ETH_MACON2_SPEC>;
#[doc = "soso"]
pub mod r8_eth_macon2;
#[doc = "R8_ETH_MABBIPG (rw) register accessor: an alias for `Reg<R8_ETH_MABBIPG_SPEC>`"]
pub type R8_ETH_MABBIPG = crate::Reg<r8_eth_mabbipg::R8_ETH_MABBIPG_SPEC>;
#[doc = "soso"]
pub mod r8_eth_mabbipg;
#[doc = "R16_ETH_EPAUS (rw) register accessor: an alias for `Reg<R16_ETH_EPAUS_SPEC>`"]
pub type R16_ETH_EPAUS = crate::Reg<r16_eth_epaus::R16_ETH_EPAUS_SPEC>;
#[doc = "soso"]
pub mod r16_eth_epaus;
#[doc = "R16_ETH_MAMXFL (rw) register accessor: an alias for `Reg<R16_ETH_MAMXFL_SPEC>`"]
pub type R16_ETH_MAMXFL = crate::Reg<r16_eth_mamxfl::R16_ETH_MAMXFL_SPEC>;
#[doc = "soso"]
pub mod r16_eth_mamxfl;
#[doc = "R16_ETH_MIRD (rw) register accessor: an alias for `Reg<R16_ETH_MIRD_SPEC>`"]
pub type R16_ETH_MIRD = crate::Reg<r16_eth_mird::R16_ETH_MIRD_SPEC>;
#[doc = "soso"]
pub mod r16_eth_mird;
#[doc = "R8_ETH_MIREGADR (rw) register accessor: an alias for `Reg<R8_ETH_MIREGADR_SPEC>`"]
pub type R8_ETH_MIREGADR = crate::Reg<r8_eth_miregadr::R8_ETH_MIREGADR_SPEC>;
#[doc = "soso"]
pub mod r8_eth_miregadr;
#[doc = "R8_ETH_MISTAT (r) register accessor: an alias for `Reg<R8_ETH_MISTAT_SPEC>`"]
pub type R8_ETH_MISTAT = crate::Reg<r8_eth_mistat::R8_ETH_MISTAT_SPEC>;
#[doc = "soso"]
pub mod r8_eth_mistat;
#[doc = "R16_ETH_MIWR (w) register accessor: an alias for `Reg<R16_ETH_MIWR_SPEC>`"]
pub type R16_ETH_MIWR = crate::Reg<r16_eth_miwr::R16_ETH_MIWR_SPEC>;
#[doc = "soso"]
pub mod r16_eth_miwr;
#[doc = "R32_ETH_MAADRL (rw) register accessor: an alias for `Reg<R32_ETH_MAADRL_SPEC>`"]
pub type R32_ETH_MAADRL = crate::Reg<r32_eth_maadrl::R32_ETH_MAADRL_SPEC>;
#[doc = "soso"]
pub mod r32_eth_maadrl;
#[doc = "R16_ETH_MAADRH (rw) register accessor: an alias for `Reg<R16_ETH_MAADRH_SPEC>`"]
pub type R16_ETH_MAADRH = crate::Reg<r16_eth_maadrh::R16_ETH_MAADRH_SPEC>;
#[doc = "soso"]
pub mod r16_eth_maadrh;
