#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - RW, PWM output enable control"]
    pub r8_pwm_out_en: R8_PWM_OUT_EN,
    #[doc = "0x01 - RW, PWM output polarity control"]
    pub r8_pwm_polar: R8_PWM_POLAR,
    #[doc = "0x02 - RW, PWM configuration"]
    pub r8_pwm_config: R8_PWM_CONFIG,
    #[doc = "0x03 - RW, PWM clock divisor"]
    pub r8_pwm_clock_div: R8_PWM_CLOCK_DIV,
    #[doc = "0x04 - RW, PWM4 data holding"]
    pub r8_pwm4_data: R8_PWM4_DATA,
    #[doc = "0x05 - RW, PWM5 data holding"]
    pub r8_pwm5_data: R8_PWM5_DATA,
    #[doc = "0x06 - RW, PWM6 data holding"]
    pub r8_pwm6_data: R8_PWM6_DATA,
    #[doc = "0x07 - RW, PWM7 data holding"]
    pub r8_pwm7_data: R8_PWM7_DATA,
    #[doc = "0x08 - RW, PWM8 data holding"]
    pub r8_pwm8_data: R8_PWM8_DATA,
    #[doc = "0x09 - RW, PWM9 data holding"]
    pub r8_pwm9_data: R8_PWM9_DATA,
    #[doc = "0x0a - RW, PWM10 data holding"]
    pub r8_pwm10_data: R8_PWM10_DATA,
    #[doc = "0x0b - RW, PWM11 data holding"]
    pub r8_pwm11_data: R8_PWM11_DATA,
}
#[doc = "R8_PWM_OUT_EN (rw) register accessor: an alias for `Reg<R8_PWM_OUT_EN_SPEC>`"]
pub type R8_PWM_OUT_EN = crate::Reg<r8_pwm_out_en::R8_PWM_OUT_EN_SPEC>;
#[doc = "RW, PWM output enable control"]
pub mod r8_pwm_out_en;
#[doc = "R8_PWM_POLAR (rw) register accessor: an alias for `Reg<R8_PWM_POLAR_SPEC>`"]
pub type R8_PWM_POLAR = crate::Reg<r8_pwm_polar::R8_PWM_POLAR_SPEC>;
#[doc = "RW, PWM output polarity control"]
pub mod r8_pwm_polar;
#[doc = "R8_PWM_CONFIG (rw) register accessor: an alias for `Reg<R8_PWM_CONFIG_SPEC>`"]
pub type R8_PWM_CONFIG = crate::Reg<r8_pwm_config::R8_PWM_CONFIG_SPEC>;
#[doc = "RW, PWM configuration"]
pub mod r8_pwm_config;
#[doc = "R8_PWM_CLOCK_DIV (rw) register accessor: an alias for `Reg<R8_PWM_CLOCK_DIV_SPEC>`"]
pub type R8_PWM_CLOCK_DIV = crate::Reg<r8_pwm_clock_div::R8_PWM_CLOCK_DIV_SPEC>;
#[doc = "RW, PWM clock divisor"]
pub mod r8_pwm_clock_div;
#[doc = "R8_PWM4_DATA (rw) register accessor: an alias for `Reg<R8_PWM4_DATA_SPEC>`"]
pub type R8_PWM4_DATA = crate::Reg<r8_pwm4_data::R8_PWM4_DATA_SPEC>;
#[doc = "RW, PWM4 data holding"]
pub mod r8_pwm4_data;
#[doc = "R8_PWM5_DATA (rw) register accessor: an alias for `Reg<R8_PWM5_DATA_SPEC>`"]
pub type R8_PWM5_DATA = crate::Reg<r8_pwm5_data::R8_PWM5_DATA_SPEC>;
#[doc = "RW, PWM5 data holding"]
pub mod r8_pwm5_data;
#[doc = "R8_PWM6_DATA (rw) register accessor: an alias for `Reg<R8_PWM6_DATA_SPEC>`"]
pub type R8_PWM6_DATA = crate::Reg<r8_pwm6_data::R8_PWM6_DATA_SPEC>;
#[doc = "RW, PWM6 data holding"]
pub mod r8_pwm6_data;
#[doc = "R8_PWM7_DATA (rw) register accessor: an alias for `Reg<R8_PWM7_DATA_SPEC>`"]
pub type R8_PWM7_DATA = crate::Reg<r8_pwm7_data::R8_PWM7_DATA_SPEC>;
#[doc = "RW, PWM7 data holding"]
pub mod r8_pwm7_data;
#[doc = "R8_PWM8_DATA (rw) register accessor: an alias for `Reg<R8_PWM8_DATA_SPEC>`"]
pub type R8_PWM8_DATA = crate::Reg<r8_pwm8_data::R8_PWM8_DATA_SPEC>;
#[doc = "RW, PWM8 data holding"]
pub mod r8_pwm8_data;
#[doc = "R8_PWM9_DATA (rw) register accessor: an alias for `Reg<R8_PWM9_DATA_SPEC>`"]
pub type R8_PWM9_DATA = crate::Reg<r8_pwm9_data::R8_PWM9_DATA_SPEC>;
#[doc = "RW, PWM9 data holding"]
pub mod r8_pwm9_data;
#[doc = "R8_PWM10_DATA (rw) register accessor: an alias for `Reg<R8_PWM10_DATA_SPEC>`"]
pub type R8_PWM10_DATA = crate::Reg<r8_pwm10_data::R8_PWM10_DATA_SPEC>;
#[doc = "RW, PWM10 data holding"]
pub mod r8_pwm10_data;
#[doc = "R8_PWM11_DATA (rw) register accessor: an alias for `Reg<R8_PWM11_DATA_SPEC>`"]
pub type R8_PWM11_DATA = crate::Reg<r8_pwm11_data::R8_PWM11_DATA_SPEC>;
#[doc = "RW, PWM11 data holding"]
pub mod r8_pwm11_data;
