#[doc = "Register `R8_PWM_CONFIG` reader"]
pub struct R(crate::R<R8_PWM_CONFIG_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_PWM_CONFIG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_PWM_CONFIG_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_PWM_CONFIG_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_PWM_CONFIG` writer"]
pub struct W(crate::W<R8_PWM_CONFIG_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_PWM_CONFIG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_PWM_CONFIG_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_PWM_CONFIG_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_PWM_CYCLE_SEL` reader - RW, PWM cycle selection: 0=256/128/64/32 clocks, 1=255/127/63/31 clocks"]
pub type RB_PWM_CYCLE_SEL_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM_CYCLE_SEL` writer - RW, PWM cycle selection: 0=256/128/64/32 clocks, 1=255/127/63/31 clocks"]
pub type RB_PWM_CYCLE_SEL_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_PWM_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_PWM_STAG_ST` reader - RO, PWM stagger cycle status"]
pub type RB_PWM_STAG_ST_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM_CYC_MOD` reader - RW, PWM data width mode: 00=8 bits data, 01=7 bits data, 10=6 bits data, 11=5 bits data"]
pub type RB_PWM_CYC_MOD_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_PWM_CYC_MOD` writer - RW, PWM data width mode: 00=8 bits data, 01=7 bits data, 10=6 bits data, 11=5 bits data"]
pub type RB_PWM_CYC_MOD_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_PWM_CONFIG_SPEC, u8, u8, 2, O>;
#[doc = "Field `RB_PWM4_5_STAG_EN` reader - RW, PWM4/5 stagger output enable: 0=independent output, 1=stagger output"]
pub type RB_PWM4_5_STAG_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM4_5_STAG_EN` writer - RW, PWM4/5 stagger output enable: 0=independent output, 1=stagger output"]
pub type RB_PWM4_5_STAG_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_PWM_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_PWM6_7_STAG_EN` reader - RW, PWM6/7 stagger output enable: 0=independent output, 1=stagger output"]
pub type RB_PWM6_7_STAG_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM6_7_STAG_EN` writer - RW, PWM6/7 stagger output enable: 0=independent output, 1=stagger output"]
pub type RB_PWM6_7_STAG_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_PWM_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_PWM8_9_STAG_EN` reader - RW, PWM8/9 stagger output enable: 0=independent output, 1=stagger output"]
pub type RB_PWM8_9_STAG_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM8_9_STAG_EN` writer - RW, PWM8/9 stagger output enable: 0=independent output, 1=stagger output"]
pub type RB_PWM8_9_STAG_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_PWM_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_PWM10_11_STAG_EN` reader - RW, PWM10/11 stagger output enable: 0=independent output, 1=stagger output"]
pub type RB_PWM10_11_STAG_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM10_11_STAG_EN` writer - RW, PWM10/11 stagger output enable: 0=independent output, 1=stagger output"]
pub type RB_PWM10_11_STAG_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_PWM_CONFIG_SPEC, bool, O>;
impl R {
    #[doc = "Bit 0 - RW, PWM cycle selection: 0=256/128/64/32 clocks, 1=255/127/63/31 clocks"]
    #[inline(always)]
    pub fn rb_pwm_cycle_sel(&self) -> RB_PWM_CYCLE_SEL_R {
        RB_PWM_CYCLE_SEL_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - RO, PWM stagger cycle status"]
    #[inline(always)]
    pub fn rb_pwm_stag_st(&self) -> RB_PWM_STAG_ST_R {
        RB_PWM_STAG_ST_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bits 2:3 - RW, PWM data width mode: 00=8 bits data, 01=7 bits data, 10=6 bits data, 11=5 bits data"]
    #[inline(always)]
    pub fn rb_pwm_cyc_mod(&self) -> RB_PWM_CYC_MOD_R {
        RB_PWM_CYC_MOD_R::new((self.bits >> 2) & 3)
    }
    #[doc = "Bit 4 - RW, PWM4/5 stagger output enable: 0=independent output, 1=stagger output"]
    #[inline(always)]
    pub fn rb_pwm4_5_stag_en(&self) -> RB_PWM4_5_STAG_EN_R {
        RB_PWM4_5_STAG_EN_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - RW, PWM6/7 stagger output enable: 0=independent output, 1=stagger output"]
    #[inline(always)]
    pub fn rb_pwm6_7_stag_en(&self) -> RB_PWM6_7_STAG_EN_R {
        RB_PWM6_7_STAG_EN_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 6 - RW, PWM8/9 stagger output enable: 0=independent output, 1=stagger output"]
    #[inline(always)]
    pub fn rb_pwm8_9_stag_en(&self) -> RB_PWM8_9_STAG_EN_R {
        RB_PWM8_9_STAG_EN_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - RW, PWM10/11 stagger output enable: 0=independent output, 1=stagger output"]
    #[inline(always)]
    pub fn rb_pwm10_11_stag_en(&self) -> RB_PWM10_11_STAG_EN_R {
        RB_PWM10_11_STAG_EN_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - RW, PWM cycle selection: 0=256/128/64/32 clocks, 1=255/127/63/31 clocks"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm_cycle_sel(&mut self) -> RB_PWM_CYCLE_SEL_W<0> {
        RB_PWM_CYCLE_SEL_W::new(self)
    }
    #[doc = "Bits 2:3 - RW, PWM data width mode: 00=8 bits data, 01=7 bits data, 10=6 bits data, 11=5 bits data"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm_cyc_mod(&mut self) -> RB_PWM_CYC_MOD_W<2> {
        RB_PWM_CYC_MOD_W::new(self)
    }
    #[doc = "Bit 4 - RW, PWM4/5 stagger output enable: 0=independent output, 1=stagger output"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm4_5_stag_en(&mut self) -> RB_PWM4_5_STAG_EN_W<4> {
        RB_PWM4_5_STAG_EN_W::new(self)
    }
    #[doc = "Bit 5 - RW, PWM6/7 stagger output enable: 0=independent output, 1=stagger output"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm6_7_stag_en(&mut self) -> RB_PWM6_7_STAG_EN_W<5> {
        RB_PWM6_7_STAG_EN_W::new(self)
    }
    #[doc = "Bit 6 - RW, PWM8/9 stagger output enable: 0=independent output, 1=stagger output"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm8_9_stag_en(&mut self) -> RB_PWM8_9_STAG_EN_W<6> {
        RB_PWM8_9_STAG_EN_W::new(self)
    }
    #[doc = "Bit 7 - RW, PWM10/11 stagger output enable: 0=independent output, 1=stagger output"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm10_11_stag_en(&mut self) -> RB_PWM10_11_STAG_EN_W<7> {
        RB_PWM10_11_STAG_EN_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, PWM configuration\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_pwm_config](index.html) module"]
pub struct R8_PWM_CONFIG_SPEC;
impl crate::RegisterSpec for R8_PWM_CONFIG_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_pwm_config::R](R) reader structure"]
impl crate::Readable for R8_PWM_CONFIG_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_pwm_config::W](W) writer structure"]
impl crate::Writable for R8_PWM_CONFIG_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_PWM_CONFIG to value 0"]
impl crate::Resettable for R8_PWM_CONFIG_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
