#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - RW, SPI1 mode control"]
    pub r8_spi1_ctrl_mod: R8_SPI1_CTRL_MOD,
    #[doc = "0x01 - RW, SPI1 configuration control"]
    pub r8_spi1_ctrl_cfg: R8_SPI1_CTRL_CFG,
    #[doc = "0x02 - RW, SPI1 interrupt enable"]
    pub r8_spi1_inter_en: R8_SPI1_INTER_EN,
    #[doc = "0x03 - RW, SPI1 master clock divisor"]
    pub r8_spi1_clock_div: R8_SPI1_CLOCK_DIV,
    #[doc = "0x04 - RW, SPI1 data buffer"]
    pub r8_spi1_buffer: R8_SPI1_BUFFER,
    #[doc = "0x05 - RO, SPI1 work flag"]
    pub r8_spi1_run_flag: R8_SPI1_RUN_FLAG,
    #[doc = "0x06 - RW1, SPI1 interrupt flag"]
    pub r8_spi1_int_flag: R8_SPI1_INT_FLAG,
    #[doc = "0x07 - RO, SPI1 FIFO count status"]
    pub r8_spi1_fifo_count: R8_SPI1_FIFO_COUNT,
    _reserved8: [u8; 0x04],
    #[doc = "0x0c - RW, SPI1 total byte count, only low 12 bit"]
    pub r16_spi1_total_cnt: R16_SPI1_TOTAL_CNT,
    _reserved9: [u8; 0x02],
    #[doc = "0x10 - RO/WO, SPI1 FIFO register"]
    pub r8_spi1_fifo: R8_SPI1_FIFO,
    _reserved10: [u8; 0x02],
    #[doc = "0x13 - RO, SPI1 FIFO count status"]
    pub r8_spi1_fifo_count1: R8_SPI1_FIFO_COUNT1,
}
#[doc = "R8_SPI1_CTRL_MOD (rw) register accessor: an alias for `Reg<R8_SPI1_CTRL_MOD_SPEC>`"]
pub type R8_SPI1_CTRL_MOD = crate::Reg<r8_spi1_ctrl_mod::R8_SPI1_CTRL_MOD_SPEC>;
#[doc = "RW, SPI1 mode control"]
pub mod r8_spi1_ctrl_mod;
#[doc = "R8_SPI1_CTRL_CFG (rw) register accessor: an alias for `Reg<R8_SPI1_CTRL_CFG_SPEC>`"]
pub type R8_SPI1_CTRL_CFG = crate::Reg<r8_spi1_ctrl_cfg::R8_SPI1_CTRL_CFG_SPEC>;
#[doc = "RW, SPI1 configuration control"]
pub mod r8_spi1_ctrl_cfg;
#[doc = "R8_SPI1_INTER_EN (rw) register accessor: an alias for `Reg<R8_SPI1_INTER_EN_SPEC>`"]
pub type R8_SPI1_INTER_EN = crate::Reg<r8_spi1_inter_en::R8_SPI1_INTER_EN_SPEC>;
#[doc = "RW, SPI1 interrupt enable"]
pub mod r8_spi1_inter_en;
#[doc = "R8_SPI1_CLOCK_DIV (rw) register accessor: an alias for `Reg<R8_SPI1_CLOCK_DIV_SPEC>`"]
pub type R8_SPI1_CLOCK_DIV = crate::Reg<r8_spi1_clock_div::R8_SPI1_CLOCK_DIV_SPEC>;
#[doc = "RW, SPI1 master clock divisor"]
pub mod r8_spi1_clock_div;
#[doc = "R8_SPI1_BUFFER (rw) register accessor: an alias for `Reg<R8_SPI1_BUFFER_SPEC>`"]
pub type R8_SPI1_BUFFER = crate::Reg<r8_spi1_buffer::R8_SPI1_BUFFER_SPEC>;
#[doc = "RW, SPI1 data buffer"]
pub mod r8_spi1_buffer;
#[doc = "R8_SPI1_RUN_FLAG (r) register accessor: an alias for `Reg<R8_SPI1_RUN_FLAG_SPEC>`"]
pub type R8_SPI1_RUN_FLAG = crate::Reg<r8_spi1_run_flag::R8_SPI1_RUN_FLAG_SPEC>;
#[doc = "RO, SPI1 work flag"]
pub mod r8_spi1_run_flag;
#[doc = "R8_SPI1_INT_FLAG (rw) register accessor: an alias for `Reg<R8_SPI1_INT_FLAG_SPEC>`"]
pub type R8_SPI1_INT_FLAG = crate::Reg<r8_spi1_int_flag::R8_SPI1_INT_FLAG_SPEC>;
#[doc = "RW1, SPI1 interrupt flag"]
pub mod r8_spi1_int_flag;
#[doc = "R8_SPI1_FIFO_COUNT (r) register accessor: an alias for `Reg<R8_SPI1_FIFO_COUNT_SPEC>`"]
pub type R8_SPI1_FIFO_COUNT = crate::Reg<r8_spi1_fifo_count::R8_SPI1_FIFO_COUNT_SPEC>;
#[doc = "RO, SPI1 FIFO count status"]
pub mod r8_spi1_fifo_count;
#[doc = "R16_SPI1_TOTAL_CNT (rw) register accessor: an alias for `Reg<R16_SPI1_TOTAL_CNT_SPEC>`"]
pub type R16_SPI1_TOTAL_CNT = crate::Reg<r16_spi1_total_cnt::R16_SPI1_TOTAL_CNT_SPEC>;
#[doc = "RW, SPI1 total byte count, only low 12 bit"]
pub mod r16_spi1_total_cnt;
#[doc = "R8_SPI1_FIFO (rw) register accessor: an alias for `Reg<R8_SPI1_FIFO_SPEC>`"]
pub type R8_SPI1_FIFO = crate::Reg<r8_spi1_fifo::R8_SPI1_FIFO_SPEC>;
#[doc = "RO/WO, SPI1 FIFO register"]
pub mod r8_spi1_fifo;
#[doc = "R8_SPI1_FIFO_COUNT1 (r) register accessor: an alias for `Reg<R8_SPI1_FIFO_COUNT1_SPEC>`"]
pub type R8_SPI1_FIFO_COUNT1 = crate::Reg<r8_spi1_fifo_count1::R8_SPI1_FIFO_COUNT1_SPEC>;
#[doc = "RO, SPI1 FIFO count status"]
pub mod r8_spi1_fifo_count1;
