#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    _reserved0: [u8; 0x08],
    #[doc = "0x08 - RWA, system clock configuration, SAM"]
    pub r16_clk_sys_cfg: R16_CLK_SYS_CFG,
    #[doc = "0x0a - RWA, high frequency clock module power control, SAM"]
    pub r8_hfck_pwr_ctrl: R8_HFCK_PWR_CTRL,
    _reserved2: [u8; 0x01],
    #[doc = "0x0c - RWA, sleep clock off control byte 0, SAM"]
    pub r8_slp_clk_off0: R8_SLP_CLK_OFF0,
    #[doc = "0x0d - RWA, sleep clock off control byte 1, SAM"]
    pub r8_slp_clk_off1: R8_SLP_CLK_OFF1,
    #[doc = "0x0e - RWA, wake control, SAM"]
    pub r8_slp_wake_ctrl: R8_SLP_WAKE_CTRL,
    #[doc = "0x0f - RWA, peripherals power down control, SAM"]
    pub r8_slp_power_ctrl: R8_SLP_POWER_CTRL,
    _reserved6: [u8; 0x08],
    #[doc = "0x18 - RW, function pin alternate configuration"]
    pub r16_pin_alternate: R16_PIN_ALTERNATE,
    #[doc = "0x1a - RW, analog pin enable and digital input disable"]
    pub r16_pin_analog_ie: R16_PIN_ANALOG_IE,
    #[doc = "0x1c - RW, parallel slave configuration"]
    pub r8_slv_config: R8_SLV_CONFIG,
    _reserved9: [u8; 0x03],
    #[doc = "0x20 - RWA, power plan before sleep instruction, SAM"]
    pub r16_power_plan: R16_POWER_PLAN,
    #[doc = "0x22 - RWA, aux power adjust control, SAM"]
    pub r8_aux_power_adj: R8_AUX_POWER_ADJ,
    _reserved11: [u8; 0x01],
    #[doc = "0x24 - RWA, battery voltage detector control, SAM"]
    pub r8_bat_det_ctrl: R8_BAT_DET_CTRL,
    #[doc = "0x25 - RWA, battery voltage detector configuration, SAM"]
    pub r8_bat_det_cfg: R8_BAT_DET_CFG,
    #[doc = "0x26 - RO, battery status"]
    pub r8_bat_status: R8_BAT_STATUS,
    _reserved14: [u8; 0x05],
    #[doc = "0x2c - RWA, internal 32KHz oscillator tune control, SAM"]
    pub r16_int32k_tune: R16_INT32K_TUNE,
    #[doc = "0x2e - RWA, external 32KHz oscillator tune control, SAM"]
    pub r8_xt32k_tune: R8_XT32K_TUNE,
    #[doc = "0x2f - RWA, 32KHz oscillator configure"]
    pub r8_ck32k_config: R8_CK32K_CONFIG,
    #[doc = "0x30 - RW, RTC flag and clear control"]
    pub r8_rtc_flag_ctrl: R8_RTC_FLAG_CTRL,
    #[doc = "0x31 - RWA, RTC mode control, SAM"]
    pub r8_rtc_mode_ctrl: R8_RTC_MODE_CTRL,
    _reserved19: [u8; 0x02],
    #[doc = "0x34 - RWA, RTC trigger value, SAM"]
    pub r32_rtc_trig: R32_RTC_TRIG,
    #[doc = "0x38 - RO, RTC count based 32KHz"]
    pub r16_rtc_cnt_32k: R16_RTC_CNT_32K,
    #[doc = "0x3a - RO, RTC count based 2 second"]
    pub r16_rtc_cnt_2s: R16_RTC_CNT_2S,
    #[doc = "0x3c - RO, RTC count based one day, only low 14 bit"]
    pub r32_rtc_cnt_day: R32_RTC_CNT_DAY,
    _reserved_23_r8_safe_access_sig: [u8; 0x01],
    #[doc = "0x41 - RF, chip ID register, always is ID_CH57*"]
    pub r8_chip_id: R8_CHIP_ID,
    #[doc = "0x42 - RF, safe accessing ID register, always 0x04"]
    pub r8_safe_access_id: R8_SAFE_ACCESS_ID,
    #[doc = "0x43 - RW, watch-dog count, count by clock frequency Fsys/131072"]
    pub r8_wdog_count: R8_WDOG_COUNT,
    #[doc = "0x44 - RWA, reset status, SAM"]
    pub r8_reset_status: R8_RESET_STATUS,
    #[doc = "0x45 - RO, global configuration information and status"]
    pub r8_glob_cfg_info: R8_GLOB_CFG_INFO,
    #[doc = "0x46 - RWA, reset and watch-dog control, SAM"]
    pub r8_rst_wdog_ctrl: R8_RST_WDOG_CTRL,
    #[doc = "0x47 - RW, value keeper during global reset"]
    pub r8_glob_reset_keep: R8_GLOB_RESET_KEEP,
    _reserved31: [u8; 0x02],
    #[doc = "0x4a - RWA, Flash ROM configure register"]
    pub r8_cfg_flash: R8_CFG_FLASH,
    #[doc = "0x4b - RWA, PLL configuration control, SAM"]
    pub r8_pll_config: R8_PLL_CONFIG,
    #[doc = "0x4c - RWA, internal 32MHz oscillator tune control, SAM"]
    pub r16_int32m_calib: R16_INT32M_CALIB,
    #[doc = "0x4e - RWA, external 32MHz oscillator tune control, SAM"]
    pub r8_xt32m_tune: R8_XT32M_TUNE,
    _reserved35: [u8; 0x01],
    #[doc = "0x50 - RO, system clock count value for 32KHz 5 cycles"]
    pub r16_osc_cal_cnt: R16_OSC_CAL_CNT,
    #[doc = "0x52 - RWA, oscillator frequency calibration control, SAM"]
    pub r8_osc_cal_ctrl: R8_OSC_CAL_CTRL,
    _reserved37: [u8; 0x05],
    #[doc = "0x58 - RW, ADC input channel selection"]
    pub r8_adc_channel: R8_ADC_CHANNEL,
    #[doc = "0x59 - RW, ADC configure"]
    pub r8_adc_cfg: R8_ADC_CFG,
    #[doc = "0x5a - RW, ADC convert control"]
    pub r8_adc_convert: R8_ADC_CONVERT,
    #[doc = "0x5b - RW, temperature sensor control"]
    pub r8_tem_sensor: R8_TEM_SENSOR,
    #[doc = "0x5c - RO, ADC data"]
    pub r16_adc_data: R16_ADC_DATA,
    #[doc = "0x5e - RO, ADC interrupt flag register"]
    pub r8_adc_int_flag: R8_ADC_INT_FLAG,
    #[doc = "0x5f - WO, Touch-key charge and discharge count"]
    pub r8_tkey_cnt: R8_TKEY_CNT,
    _reserved44: [u8; 0x30],
    #[doc = "0x90 - RW, GPIO PA interrupt enable"]
    pub r16_pa_int_en: R16_PA_INT_EN,
    #[doc = "0x92 - RW, GPIO PB interrupt enable"]
    pub r16_pb_int_en: R16_PB_INT_EN,
    #[doc = "0x94 - RW, GPIO PA interrupt mode: 0=level action, 1=edge action"]
    pub r16_pa_int_mode: R16_PA_INT_MODE,
    _reserved_47_r8_slv_wr_data: [u8; 0x02],
    _reserved48: [u8; 0x04],
    #[doc = "0x9c - RW1, GPIO PA interrupt flag"]
    pub r16_pa_int_if: R16_PA_INT_IF,
    #[doc = "0x9e - RW1, GPIO PB interrupt flag"]
    pub r16_pb_int_if: R16_PB_INT_IF,
    #[doc = "0xa0 - RW, GPIO PA I/O direction: 0=in, 1=out"]
    pub r32_pa_dir: R32_PA_DIR,
    #[doc = "0xa4 - RO, GPIO PA input"]
    pub r32_pa_pin: R32_PA_PIN,
    #[doc = "0xa8 - RW, GPIO PA output"]
    pub r32_pa_out: R32_PA_OUT,
    #[doc = "0xac - WZ, GPIO PA clear output: 0=keep, 1=clear"]
    pub r32_pa_clr: R32_PA_CLR,
    #[doc = "0xb0 - RW, GPIO PA pullup resistance enable"]
    pub r32_pa_pu: R32_PA_PU,
    #[doc = "0xb4 - RW, PA pulldown for input or PA driving capability for output"]
    pub r32_pa_pd_drv: R32_PA_PD_DRV,
    _reserved56: [u8; 0x08],
    #[doc = "0xc0 - RW, GPIO PB I/O direction: 0=in, 1=out"]
    pub r32_pb_dir: R32_PB_DIR,
    #[doc = "0xc4 - RO, GPIO PB input"]
    pub r32_pb_pin: R32_PB_PIN,
    #[doc = "0xc8 - RW, GPIO PB output;RW, data for parallel slave read"]
    pub r32_pb_out__r8_slv_rd_data: R32_PB_OUT__R8_SLV_RD_DATA,
    #[doc = "0xcc - WZ, GPIO PB clear output: 0=keep, 1=clear"]
    pub r32_pb_clr: R32_PB_CLR,
    #[doc = "0xd0 - RW, GPIO PB pullup resistance enable"]
    pub r32_pb_pu: R32_PB_PU,
    #[doc = "0xd4 - RW, PB pulldown for input or PB driving capability for output"]
    pub r32_pb_pd_drv: R32_PB_PD_DRV,
}
impl RegisterBlock {
    #[doc = "0x40 - safe accessing sign register, must write 0x57 then 0xA8 to enter safe accessing mode"]
    #[inline(always)]
    pub const fn r8_safe_access_sig_wr(&self) -> &R8_SAFE_ACCESS_SIG_WR {
        unsafe { &*(self as *const Self).cast::<u8>().add(64usize).cast() }
    }
    #[doc = "0x40 - R8_SAFE_ACCESS_SIG_RD Register safe accessing"]
    #[inline(always)]
    pub const fn r8_safe_access_sig_rd(&self) -> &R8_SAFE_ACCESS_SIG_RD {
        unsafe { &*(self as *const Self).cast::<u8>().add(64usize).cast() }
    }
    #[doc = "0x96 - RW, GPIO PB interrupt mode: 0=level action, 1=edge action;RW, status for parallel slave read"]
    #[inline(always)]
    pub const fn r16_pb_int_mode__r8_slv_rd_stat(&self) -> &R16_PB_INT_MODE__R8_SLV_RD_STAT {
        unsafe { &*(self as *const Self).cast::<u8>().add(150usize).cast() }
    }
    #[doc = "0x97 - RW, data or command from parallel slave write"]
    #[inline(always)]
    pub const fn r8_slv_wr_data(&self) -> &R8_SLV_WR_DATA {
        unsafe { &*(self as *const Self).cast::<u8>().add(151usize).cast() }
    }
}
#[doc = "R16_CLK_SYS_CFG (rw) register accessor: an alias for `Reg<R16_CLK_SYS_CFG_SPEC>`"]
pub type R16_CLK_SYS_CFG = crate::Reg<r16_clk_sys_cfg::R16_CLK_SYS_CFG_SPEC>;
#[doc = "RWA, system clock configuration, SAM"]
pub mod r16_clk_sys_cfg;
#[doc = "R8_HFCK_PWR_CTRL (rw) register accessor: an alias for `Reg<R8_HFCK_PWR_CTRL_SPEC>`"]
pub type R8_HFCK_PWR_CTRL = crate::Reg<r8_hfck_pwr_ctrl::R8_HFCK_PWR_CTRL_SPEC>;
#[doc = "RWA, high frequency clock module power control, SAM"]
pub mod r8_hfck_pwr_ctrl;
#[doc = "R8_SLP_CLK_OFF0 (rw) register accessor: an alias for `Reg<R8_SLP_CLK_OFF0_SPEC>`"]
pub type R8_SLP_CLK_OFF0 = crate::Reg<r8_slp_clk_off0::R8_SLP_CLK_OFF0_SPEC>;
#[doc = "RWA, sleep clock off control byte 0, SAM"]
pub mod r8_slp_clk_off0;
#[doc = "R8_SLP_CLK_OFF1 (rw) register accessor: an alias for `Reg<R8_SLP_CLK_OFF1_SPEC>`"]
pub type R8_SLP_CLK_OFF1 = crate::Reg<r8_slp_clk_off1::R8_SLP_CLK_OFF1_SPEC>;
#[doc = "RWA, sleep clock off control byte 1, SAM"]
pub mod r8_slp_clk_off1;
#[doc = "R8_SLP_WAKE_CTRL (rw) register accessor: an alias for `Reg<R8_SLP_WAKE_CTRL_SPEC>`"]
pub type R8_SLP_WAKE_CTRL = crate::Reg<r8_slp_wake_ctrl::R8_SLP_WAKE_CTRL_SPEC>;
#[doc = "RWA, wake control, SAM"]
pub mod r8_slp_wake_ctrl;
#[doc = "R8_SLP_POWER_CTRL (rw) register accessor: an alias for `Reg<R8_SLP_POWER_CTRL_SPEC>`"]
pub type R8_SLP_POWER_CTRL = crate::Reg<r8_slp_power_ctrl::R8_SLP_POWER_CTRL_SPEC>;
#[doc = "RWA, peripherals power down control, SAM"]
pub mod r8_slp_power_ctrl;
#[doc = "R16_PIN_ALTERNATE (rw) register accessor: an alias for `Reg<R16_PIN_ALTERNATE_SPEC>`"]
pub type R16_PIN_ALTERNATE = crate::Reg<r16_pin_alternate::R16_PIN_ALTERNATE_SPEC>;
#[doc = "RW, function pin alternate configuration"]
pub mod r16_pin_alternate;
#[doc = "R16_PIN_ANALOG_IE (rw) register accessor: an alias for `Reg<R16_PIN_ANALOG_IE_SPEC>`"]
pub type R16_PIN_ANALOG_IE = crate::Reg<r16_pin_analog_ie::R16_PIN_ANALOG_IE_SPEC>;
#[doc = "RW, analog pin enable and digital input disable"]
pub mod r16_pin_analog_ie;
#[doc = "R8_SLV_CONFIG (rw) register accessor: an alias for `Reg<R8_SLV_CONFIG_SPEC>`"]
pub type R8_SLV_CONFIG = crate::Reg<r8_slv_config::R8_SLV_CONFIG_SPEC>;
#[doc = "RW, parallel slave configuration"]
pub mod r8_slv_config;
#[doc = "R16_POWER_PLAN (rw) register accessor: an alias for `Reg<R16_POWER_PLAN_SPEC>`"]
pub type R16_POWER_PLAN = crate::Reg<r16_power_plan::R16_POWER_PLAN_SPEC>;
#[doc = "RWA, power plan before sleep instruction, SAM"]
pub mod r16_power_plan;
#[doc = "R8_AUX_POWER_ADJ (rw) register accessor: an alias for `Reg<R8_AUX_POWER_ADJ_SPEC>`"]
pub type R8_AUX_POWER_ADJ = crate::Reg<r8_aux_power_adj::R8_AUX_POWER_ADJ_SPEC>;
#[doc = "RWA, aux power adjust control, SAM"]
pub mod r8_aux_power_adj;
#[doc = "R8_BAT_DET_CTRL (rw) register accessor: an alias for `Reg<R8_BAT_DET_CTRL_SPEC>`"]
pub type R8_BAT_DET_CTRL = crate::Reg<r8_bat_det_ctrl::R8_BAT_DET_CTRL_SPEC>;
#[doc = "RWA, battery voltage detector control, SAM"]
pub mod r8_bat_det_ctrl;
#[doc = "R8_BAT_DET_CFG (rw) register accessor: an alias for `Reg<R8_BAT_DET_CFG_SPEC>`"]
pub type R8_BAT_DET_CFG = crate::Reg<r8_bat_det_cfg::R8_BAT_DET_CFG_SPEC>;
#[doc = "RWA, battery voltage detector configuration, SAM"]
pub mod r8_bat_det_cfg;
#[doc = "R8_BAT_STATUS (r) register accessor: an alias for `Reg<R8_BAT_STATUS_SPEC>`"]
pub type R8_BAT_STATUS = crate::Reg<r8_bat_status::R8_BAT_STATUS_SPEC>;
#[doc = "RO, battery status"]
pub mod r8_bat_status;
#[doc = "R16_INT32K_TUNE (rw) register accessor: an alias for `Reg<R16_INT32K_TUNE_SPEC>`"]
pub type R16_INT32K_TUNE = crate::Reg<r16_int32k_tune::R16_INT32K_TUNE_SPEC>;
#[doc = "RWA, internal 32KHz oscillator tune control, SAM"]
pub mod r16_int32k_tune;
#[doc = "R8_XT32K_TUNE (rw) register accessor: an alias for `Reg<R8_XT32K_TUNE_SPEC>`"]
pub type R8_XT32K_TUNE = crate::Reg<r8_xt32k_tune::R8_XT32K_TUNE_SPEC>;
#[doc = "RWA, external 32KHz oscillator tune control, SAM"]
pub mod r8_xt32k_tune;
#[doc = "R8_CK32K_CONFIG (rw) register accessor: an alias for `Reg<R8_CK32K_CONFIG_SPEC>`"]
pub type R8_CK32K_CONFIG = crate::Reg<r8_ck32k_config::R8_CK32K_CONFIG_SPEC>;
#[doc = "RWA, 32KHz oscillator configure"]
pub mod r8_ck32k_config;
#[doc = "R8_RTC_FLAG_CTRL (rw) register accessor: an alias for `Reg<R8_RTC_FLAG_CTRL_SPEC>`"]
pub type R8_RTC_FLAG_CTRL = crate::Reg<r8_rtc_flag_ctrl::R8_RTC_FLAG_CTRL_SPEC>;
#[doc = "RW, RTC flag and clear control"]
pub mod r8_rtc_flag_ctrl;
#[doc = "R8_RTC_MODE_CTRL (rw) register accessor: an alias for `Reg<R8_RTC_MODE_CTRL_SPEC>`"]
pub type R8_RTC_MODE_CTRL = crate::Reg<r8_rtc_mode_ctrl::R8_RTC_MODE_CTRL_SPEC>;
#[doc = "RWA, RTC mode control, SAM"]
pub mod r8_rtc_mode_ctrl;
#[doc = "R32_RTC_TRIG (rw) register accessor: an alias for `Reg<R32_RTC_TRIG_SPEC>`"]
pub type R32_RTC_TRIG = crate::Reg<r32_rtc_trig::R32_RTC_TRIG_SPEC>;
#[doc = "RWA, RTC trigger value, SAM"]
pub mod r32_rtc_trig;
#[doc = "R16_RTC_CNT_32K (r) register accessor: an alias for `Reg<R16_RTC_CNT_32K_SPEC>`"]
pub type R16_RTC_CNT_32K = crate::Reg<r16_rtc_cnt_32k::R16_RTC_CNT_32K_SPEC>;
#[doc = "RO, RTC count based 32KHz"]
pub mod r16_rtc_cnt_32k;
#[doc = "R16_RTC_CNT_2S (r) register accessor: an alias for `Reg<R16_RTC_CNT_2S_SPEC>`"]
pub type R16_RTC_CNT_2S = crate::Reg<r16_rtc_cnt_2s::R16_RTC_CNT_2S_SPEC>;
#[doc = "RO, RTC count based 2 second"]
pub mod r16_rtc_cnt_2s;
#[doc = "R32_RTC_CNT_DAY (r) register accessor: an alias for `Reg<R32_RTC_CNT_DAY_SPEC>`"]
pub type R32_RTC_CNT_DAY = crate::Reg<r32_rtc_cnt_day::R32_RTC_CNT_DAY_SPEC>;
#[doc = "RO, RTC count based one day, only low 14 bit"]
pub mod r32_rtc_cnt_day;
#[doc = "R8_SAFE_ACCESS_SIG_RD (r) register accessor: an alias for `Reg<R8_SAFE_ACCESS_SIG_RD_SPEC>`"]
pub type R8_SAFE_ACCESS_SIG_RD = crate::Reg<r8_safe_access_sig_rd::R8_SAFE_ACCESS_SIG_RD_SPEC>;
#[doc = "R8_SAFE_ACCESS_SIG_RD Register safe accessing"]
pub mod r8_safe_access_sig_rd;
#[doc = "R8_SAFE_ACCESS_SIG_WR (w) register accessor: an alias for `Reg<R8_SAFE_ACCESS_SIG_WR_SPEC>`"]
pub type R8_SAFE_ACCESS_SIG_WR = crate::Reg<r8_safe_access_sig_wr::R8_SAFE_ACCESS_SIG_WR_SPEC>;
#[doc = "safe accessing sign register, must write 0x57 then 0xA8 to enter safe accessing mode"]
pub mod r8_safe_access_sig_wr;
#[doc = "R8_CHIP_ID (r) register accessor: an alias for `Reg<R8_CHIP_ID_SPEC>`"]
pub type R8_CHIP_ID = crate::Reg<r8_chip_id::R8_CHIP_ID_SPEC>;
#[doc = "RF, chip ID register, always is ID_CH57*"]
pub mod r8_chip_id;
#[doc = "R8_SAFE_ACCESS_ID (r) register accessor: an alias for `Reg<R8_SAFE_ACCESS_ID_SPEC>`"]
pub type R8_SAFE_ACCESS_ID = crate::Reg<r8_safe_access_id::R8_SAFE_ACCESS_ID_SPEC>;
#[doc = "RF, safe accessing ID register, always 0x04"]
pub mod r8_safe_access_id;
#[doc = "R8_WDOG_COUNT (rw) register accessor: an alias for `Reg<R8_WDOG_COUNT_SPEC>`"]
pub type R8_WDOG_COUNT = crate::Reg<r8_wdog_count::R8_WDOG_COUNT_SPEC>;
#[doc = "RW, watch-dog count, count by clock frequency Fsys/131072"]
pub mod r8_wdog_count;
#[doc = "R8_RESET_STATUS (rw) register accessor: an alias for `Reg<R8_RESET_STATUS_SPEC>`"]
pub type R8_RESET_STATUS = crate::Reg<r8_reset_status::R8_RESET_STATUS_SPEC>;
#[doc = "RWA, reset status, SAM"]
pub mod r8_reset_status;
#[doc = "R8_GLOB_CFG_INFO (r) register accessor: an alias for `Reg<R8_GLOB_CFG_INFO_SPEC>`"]
pub type R8_GLOB_CFG_INFO = crate::Reg<r8_glob_cfg_info::R8_GLOB_CFG_INFO_SPEC>;
#[doc = "RO, global configuration information and status"]
pub mod r8_glob_cfg_info;
#[doc = "R8_RST_WDOG_CTRL (rw) register accessor: an alias for `Reg<R8_RST_WDOG_CTRL_SPEC>`"]
pub type R8_RST_WDOG_CTRL = crate::Reg<r8_rst_wdog_ctrl::R8_RST_WDOG_CTRL_SPEC>;
#[doc = "RWA, reset and watch-dog control, SAM"]
pub mod r8_rst_wdog_ctrl;
#[doc = "R8_GLOB_RESET_KEEP (rw) register accessor: an alias for `Reg<R8_GLOB_RESET_KEEP_SPEC>`"]
pub type R8_GLOB_RESET_KEEP = crate::Reg<r8_glob_reset_keep::R8_GLOB_RESET_KEEP_SPEC>;
#[doc = "RW, value keeper during global reset"]
pub mod r8_glob_reset_keep;
#[doc = "R8_CFG_FLASH (rw) register accessor: an alias for `Reg<R8_CFG_FLASH_SPEC>`"]
pub type R8_CFG_FLASH = crate::Reg<r8_cfg_flash::R8_CFG_FLASH_SPEC>;
#[doc = "RWA, Flash ROM configure register"]
pub mod r8_cfg_flash;
#[doc = "R8_PLL_CONFIG (rw) register accessor: an alias for `Reg<R8_PLL_CONFIG_SPEC>`"]
pub type R8_PLL_CONFIG = crate::Reg<r8_pll_config::R8_PLL_CONFIG_SPEC>;
#[doc = "RWA, PLL configuration control, SAM"]
pub mod r8_pll_config;
#[doc = "R16_INT32M_CALIB (rw) register accessor: an alias for `Reg<R16_INT32M_CALIB_SPEC>`"]
pub type R16_INT32M_CALIB = crate::Reg<r16_int32m_calib::R16_INT32M_CALIB_SPEC>;
#[doc = "RWA, internal 32MHz oscillator tune control, SAM"]
pub mod r16_int32m_calib;
#[doc = "R8_XT32M_TUNE (rw) register accessor: an alias for `Reg<R8_XT32M_TUNE_SPEC>`"]
pub type R8_XT32M_TUNE = crate::Reg<r8_xt32m_tune::R8_XT32M_TUNE_SPEC>;
#[doc = "RWA, external 32MHz oscillator tune control, SAM"]
pub mod r8_xt32m_tune;
#[doc = "R16_OSC_CAL_CNT (r) register accessor: an alias for `Reg<R16_OSC_CAL_CNT_SPEC>`"]
pub type R16_OSC_CAL_CNT = crate::Reg<r16_osc_cal_cnt::R16_OSC_CAL_CNT_SPEC>;
#[doc = "RO, system clock count value for 32KHz 5 cycles"]
pub mod r16_osc_cal_cnt;
#[doc = "R8_OSC_CAL_CTRL (rw) register accessor: an alias for `Reg<R8_OSC_CAL_CTRL_SPEC>`"]
pub type R8_OSC_CAL_CTRL = crate::Reg<r8_osc_cal_ctrl::R8_OSC_CAL_CTRL_SPEC>;
#[doc = "RWA, oscillator frequency calibration control, SAM"]
pub mod r8_osc_cal_ctrl;
#[doc = "R8_ADC_CHANNEL (rw) register accessor: an alias for `Reg<R8_ADC_CHANNEL_SPEC>`"]
pub type R8_ADC_CHANNEL = crate::Reg<r8_adc_channel::R8_ADC_CHANNEL_SPEC>;
#[doc = "RW, ADC input channel selection"]
pub mod r8_adc_channel;
#[doc = "R8_ADC_CFG (rw) register accessor: an alias for `Reg<R8_ADC_CFG_SPEC>`"]
pub type R8_ADC_CFG = crate::Reg<r8_adc_cfg::R8_ADC_CFG_SPEC>;
#[doc = "RW, ADC configure"]
pub mod r8_adc_cfg;
#[doc = "R8_ADC_CONVERT (rw) register accessor: an alias for `Reg<R8_ADC_CONVERT_SPEC>`"]
pub type R8_ADC_CONVERT = crate::Reg<r8_adc_convert::R8_ADC_CONVERT_SPEC>;
#[doc = "RW, ADC convert control"]
pub mod r8_adc_convert;
#[doc = "R8_TEM_SENSOR (rw) register accessor: an alias for `Reg<R8_TEM_SENSOR_SPEC>`"]
pub type R8_TEM_SENSOR = crate::Reg<r8_tem_sensor::R8_TEM_SENSOR_SPEC>;
#[doc = "RW, temperature sensor control"]
pub mod r8_tem_sensor;
#[doc = "R16_ADC_DATA (r) register accessor: an alias for `Reg<R16_ADC_DATA_SPEC>`"]
pub type R16_ADC_DATA = crate::Reg<r16_adc_data::R16_ADC_DATA_SPEC>;
#[doc = "RO, ADC data"]
pub mod r16_adc_data;
#[doc = "R8_ADC_INT_FLAG (r) register accessor: an alias for `Reg<R8_ADC_INT_FLAG_SPEC>`"]
pub type R8_ADC_INT_FLAG = crate::Reg<r8_adc_int_flag::R8_ADC_INT_FLAG_SPEC>;
#[doc = "RO, ADC interrupt flag register"]
pub mod r8_adc_int_flag;
#[doc = "R8_TKEY_CNT (w) register accessor: an alias for `Reg<R8_TKEY_CNT_SPEC>`"]
pub type R8_TKEY_CNT = crate::Reg<r8_tkey_cnt::R8_TKEY_CNT_SPEC>;
#[doc = "WO, Touch-key charge and discharge count"]
pub mod r8_tkey_cnt;
#[doc = "R16_PA_INT_EN (rw) register accessor: an alias for `Reg<R16_PA_INT_EN_SPEC>`"]
pub type R16_PA_INT_EN = crate::Reg<r16_pa_int_en::R16_PA_INT_EN_SPEC>;
#[doc = "RW, GPIO PA interrupt enable"]
pub mod r16_pa_int_en;
#[doc = "R16_PB_INT_EN (rw) register accessor: an alias for `Reg<R16_PB_INT_EN_SPEC>`"]
pub type R16_PB_INT_EN = crate::Reg<r16_pb_int_en::R16_PB_INT_EN_SPEC>;
#[doc = "RW, GPIO PB interrupt enable"]
pub mod r16_pb_int_en;
#[doc = "R16_PA_INT_MODE (rw) register accessor: an alias for `Reg<R16_PA_INT_MODE_SPEC>`"]
pub type R16_PA_INT_MODE = crate::Reg<r16_pa_int_mode::R16_PA_INT_MODE_SPEC>;
#[doc = "RW, GPIO PA interrupt mode: 0=level action, 1=edge action"]
pub mod r16_pa_int_mode;
#[doc = "R16_PB_INT_MODE__R8_SLV_RD_STAT (rw) register accessor: an alias for `Reg<R16_PB_INT_MODE__R8_SLV_RD_STAT_SPEC>`"]
pub type R16_PB_INT_MODE__R8_SLV_RD_STAT =
    crate::Reg<r16_pb_int_mode__r8_slv_rd_stat::R16_PB_INT_MODE__R8_SLV_RD_STAT_SPEC>;
#[doc = "RW, GPIO PB interrupt mode: 0=level action, 1=edge action;RW, status for parallel slave read"]
pub mod r16_pb_int_mode__r8_slv_rd_stat;
#[doc = "R8_SLV_WR_DATA (rw) register accessor: an alias for `Reg<R8_SLV_WR_DATA_SPEC>`"]
pub type R8_SLV_WR_DATA = crate::Reg<r8_slv_wr_data::R8_SLV_WR_DATA_SPEC>;
#[doc = "RW, data or command from parallel slave write"]
pub mod r8_slv_wr_data;
#[doc = "R16_PA_INT_IF (rw) register accessor: an alias for `Reg<R16_PA_INT_IF_SPEC>`"]
pub type R16_PA_INT_IF = crate::Reg<r16_pa_int_if::R16_PA_INT_IF_SPEC>;
#[doc = "RW1, GPIO PA interrupt flag"]
pub mod r16_pa_int_if;
#[doc = "R16_PB_INT_IF (rw) register accessor: an alias for `Reg<R16_PB_INT_IF_SPEC>`"]
pub type R16_PB_INT_IF = crate::Reg<r16_pb_int_if::R16_PB_INT_IF_SPEC>;
#[doc = "RW1, GPIO PB interrupt flag"]
pub mod r16_pb_int_if;
#[doc = "R32_PA_DIR (rw) register accessor: an alias for `Reg<R32_PA_DIR_SPEC>`"]
pub type R32_PA_DIR = crate::Reg<r32_pa_dir::R32_PA_DIR_SPEC>;
#[doc = "RW, GPIO PA I/O direction: 0=in, 1=out"]
pub mod r32_pa_dir;
#[doc = "R32_PA_PIN (r) register accessor: an alias for `Reg<R32_PA_PIN_SPEC>`"]
pub type R32_PA_PIN = crate::Reg<r32_pa_pin::R32_PA_PIN_SPEC>;
#[doc = "RO, GPIO PA input"]
pub mod r32_pa_pin;
#[doc = "R32_PA_OUT (rw) register accessor: an alias for `Reg<R32_PA_OUT_SPEC>`"]
pub type R32_PA_OUT = crate::Reg<r32_pa_out::R32_PA_OUT_SPEC>;
#[doc = "RW, GPIO PA output"]
pub mod r32_pa_out;
#[doc = "R32_PA_CLR (rw) register accessor: an alias for `Reg<R32_PA_CLR_SPEC>`"]
pub type R32_PA_CLR = crate::Reg<r32_pa_clr::R32_PA_CLR_SPEC>;
#[doc = "WZ, GPIO PA clear output: 0=keep, 1=clear"]
pub mod r32_pa_clr;
#[doc = "R32_PA_PU (rw) register accessor: an alias for `Reg<R32_PA_PU_SPEC>`"]
pub type R32_PA_PU = crate::Reg<r32_pa_pu::R32_PA_PU_SPEC>;
#[doc = "RW, GPIO PA pullup resistance enable"]
pub mod r32_pa_pu;
#[doc = "R32_PA_PD_DRV (rw) register accessor: an alias for `Reg<R32_PA_PD_DRV_SPEC>`"]
pub type R32_PA_PD_DRV = crate::Reg<r32_pa_pd_drv::R32_PA_PD_DRV_SPEC>;
#[doc = "RW, PA pulldown for input or PA driving capability for output"]
pub mod r32_pa_pd_drv;
#[doc = "R32_PB_DIR (rw) register accessor: an alias for `Reg<R32_PB_DIR_SPEC>`"]
pub type R32_PB_DIR = crate::Reg<r32_pb_dir::R32_PB_DIR_SPEC>;
#[doc = "RW, GPIO PB I/O direction: 0=in, 1=out"]
pub mod r32_pb_dir;
#[doc = "R32_PB_PIN (r) register accessor: an alias for `Reg<R32_PB_PIN_SPEC>`"]
pub type R32_PB_PIN = crate::Reg<r32_pb_pin::R32_PB_PIN_SPEC>;
#[doc = "RO, GPIO PB input"]
pub mod r32_pb_pin;
#[doc = "R32_PB_OUT__R8_SLV_RD_DATA (rw) register accessor: an alias for `Reg<R32_PB_OUT__R8_SLV_RD_DATA_SPEC>`"]
pub type R32_PB_OUT__R8_SLV_RD_DATA =
    crate::Reg<r32_pb_out__r8_slv_rd_data::R32_PB_OUT__R8_SLV_RD_DATA_SPEC>;
#[doc = "RW, GPIO PB output;RW, data for parallel slave read"]
pub mod r32_pb_out__r8_slv_rd_data;
#[doc = "R32_PB_CLR (rw) register accessor: an alias for `Reg<R32_PB_CLR_SPEC>`"]
pub type R32_PB_CLR = crate::Reg<r32_pb_clr::R32_PB_CLR_SPEC>;
#[doc = "WZ, GPIO PB clear output: 0=keep, 1=clear"]
pub mod r32_pb_clr;
#[doc = "R32_PB_PU (rw) register accessor: an alias for `Reg<R32_PB_PU_SPEC>`"]
pub type R32_PB_PU = crate::Reg<r32_pb_pu::R32_PB_PU_SPEC>;
#[doc = "RW, GPIO PB pullup resistance enable"]
pub mod r32_pb_pu;
#[doc = "R32_PB_PD_DRV (rw) register accessor: an alias for `Reg<R32_PB_PD_DRV_SPEC>`"]
pub type R32_PB_PD_DRV = crate::Reg<r32_pb_pd_drv::R32_PB_PD_DRV_SPEC>;
#[doc = "RW, PB pulldown for input or PB driving capability for output"]
pub mod r32_pb_pd_drv;
