#[doc = "Register `R16_POWER_PLAN` reader"]
pub struct R(crate::R<R16_POWER_PLAN_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R16_POWER_PLAN_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R16_POWER_PLAN_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R16_POWER_PLAN_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R16_POWER_PLAN` writer"]
pub struct W(crate::W<R16_POWER_PLAN_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R16_POWER_PLAN_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R16_POWER_PLAN_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R16_POWER_PLAN_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_PWR_RAM2K` reader - RWA, power for retention 2KB SRAM"]
pub type RB_PWR_RAM2K_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWR_RAM2K` writer - RWA, power for retention 2KB SRAM"]
pub type RB_PWR_RAM2K_W<'a, const O: u8> = crate::BitWriter<'a, u16, R16_POWER_PLAN_SPEC, bool, O>;
#[doc = "Field `RB_PWR_CORE` reader - RWA, power retention for core and base peripherals"]
pub type RB_PWR_CORE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWR_CORE` writer - RWA, power retention for core and base peripherals"]
pub type RB_PWR_CORE_W<'a, const O: u8> = crate::BitWriter<'a, u16, R16_POWER_PLAN_SPEC, bool, O>;
#[doc = "Field `RB_PWR_EXTEND` reader - RWA, power retention for USB and BLE"]
pub type RB_PWR_EXTEND_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWR_EXTEND` writer - RWA, power retention for USB and BLE"]
pub type RB_PWR_EXTEND_W<'a, const O: u8> = crate::BitWriter<'a, u16, R16_POWER_PLAN_SPEC, bool, O>;
#[doc = "Field `RB_PWR_RAM14K` reader - RWA, power for main SRAM"]
pub type RB_PWR_RAM14K_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWR_RAM14K` writer - RWA, power for main SRAM"]
pub type RB_PWR_RAM14K_W<'a, const O: u8> = crate::BitWriter<'a, u16, R16_POWER_PLAN_SPEC, bool, O>;
#[doc = "Field `RB_PWR_SYS_EN` reader - RWA, power for system"]
pub type RB_PWR_SYS_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWR_SYS_EN` writer - RWA, power for system"]
pub type RB_PWR_SYS_EN_W<'a, const O: u8> = crate::BitWriter<'a, u16, R16_POWER_PLAN_SPEC, bool, O>;
#[doc = "Field `RB_PWR_MUST_1` reader - RWA, must write 1"]
pub type RB_PWR_MUST_1_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWR_DCDC_EN` reader - RWA, DC/DC converter enable: 0=DC/DC disable and bypass, 1=DC/DC enable"]
pub type RB_PWR_DCDC_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWR_DCDC_EN` writer - RWA, DC/DC converter enable: 0=DC/DC disable and bypass, 1=DC/DC enable"]
pub type RB_PWR_DCDC_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_POWER_PLAN_SPEC, bool, O>;
#[doc = "Field `RB_PWR_DCDC_PRE` reader - RWA, DC/DC converter pre-enable"]
pub type RB_PWR_DCDC_PRE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWR_DCDC_PRE` writer - RWA, DC/DC converter pre-enable"]
pub type RB_PWR_DCDC_PRE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_POWER_PLAN_SPEC, bool, O>;
#[doc = "Field `RB_PWR_MUST_0010` reader - RWA, must write 0010"]
pub type RB_PWR_MUST_0010_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_PWR_PLAN_EN` reader - RWA/WZ, power plan enable, auto clear after sleep executed"]
pub type RB_PWR_PLAN_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWR_PLAN_EN` writer - RWA/WZ, power plan enable, auto clear after sleep executed"]
pub type RB_PWR_PLAN_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_POWER_PLAN_SPEC, bool, O>;
impl R {
    #[doc = "Bit 1 - RWA, power for retention 2KB SRAM"]
    #[inline(always)]
    pub fn rb_pwr_ram2k(&self) -> RB_PWR_RAM2K_R {
        RB_PWR_RAM2K_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - RWA, power retention for core and base peripherals"]
    #[inline(always)]
    pub fn rb_pwr_core(&self) -> RB_PWR_CORE_R {
        RB_PWR_CORE_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - RWA, power retention for USB and BLE"]
    #[inline(always)]
    pub fn rb_pwr_extend(&self) -> RB_PWR_EXTEND_R {
        RB_PWR_EXTEND_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - RWA, power for main SRAM"]
    #[inline(always)]
    pub fn rb_pwr_ram14k(&self) -> RB_PWR_RAM14K_R {
        RB_PWR_RAM14K_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 7 - RWA, power for system"]
    #[inline(always)]
    pub fn rb_pwr_sys_en(&self) -> RB_PWR_SYS_EN_R {
        RB_PWR_SYS_EN_R::new(((self.bits >> 7) & 1) != 0)
    }
    #[doc = "Bit 8 - RWA, must write 1"]
    #[inline(always)]
    pub fn rb_pwr_must_1(&self) -> RB_PWR_MUST_1_R {
        RB_PWR_MUST_1_R::new(((self.bits >> 8) & 1) != 0)
    }
    #[doc = "Bit 9 - RWA, DC/DC converter enable: 0=DC/DC disable and bypass, 1=DC/DC enable"]
    #[inline(always)]
    pub fn rb_pwr_dcdc_en(&self) -> RB_PWR_DCDC_EN_R {
        RB_PWR_DCDC_EN_R::new(((self.bits >> 9) & 1) != 0)
    }
    #[doc = "Bit 10 - RWA, DC/DC converter pre-enable"]
    #[inline(always)]
    pub fn rb_pwr_dcdc_pre(&self) -> RB_PWR_DCDC_PRE_R {
        RB_PWR_DCDC_PRE_R::new(((self.bits >> 10) & 1) != 0)
    }
    #[doc = "Bits 11:14 - RWA, must write 0010"]
    #[inline(always)]
    pub fn rb_pwr_must_0010(&self) -> RB_PWR_MUST_0010_R {
        RB_PWR_MUST_0010_R::new(((self.bits >> 11) & 0x0f) as u8)
    }
    #[doc = "Bit 15 - RWA/WZ, power plan enable, auto clear after sleep executed"]
    #[inline(always)]
    pub fn rb_pwr_plan_en(&self) -> RB_PWR_PLAN_EN_R {
        RB_PWR_PLAN_EN_R::new(((self.bits >> 15) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 1 - RWA, power for retention 2KB SRAM"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwr_ram2k(&mut self) -> RB_PWR_RAM2K_W<1> {
        RB_PWR_RAM2K_W::new(self)
    }
    #[doc = "Bit 2 - RWA, power retention for core and base peripherals"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwr_core(&mut self) -> RB_PWR_CORE_W<2> {
        RB_PWR_CORE_W::new(self)
    }
    #[doc = "Bit 3 - RWA, power retention for USB and BLE"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwr_extend(&mut self) -> RB_PWR_EXTEND_W<3> {
        RB_PWR_EXTEND_W::new(self)
    }
    #[doc = "Bit 4 - RWA, power for main SRAM"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwr_ram14k(&mut self) -> RB_PWR_RAM14K_W<4> {
        RB_PWR_RAM14K_W::new(self)
    }
    #[doc = "Bit 7 - RWA, power for system"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwr_sys_en(&mut self) -> RB_PWR_SYS_EN_W<7> {
        RB_PWR_SYS_EN_W::new(self)
    }
    #[doc = "Bit 9 - RWA, DC/DC converter enable: 0=DC/DC disable and bypass, 1=DC/DC enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwr_dcdc_en(&mut self) -> RB_PWR_DCDC_EN_W<9> {
        RB_PWR_DCDC_EN_W::new(self)
    }
    #[doc = "Bit 10 - RWA, DC/DC converter pre-enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwr_dcdc_pre(&mut self) -> RB_PWR_DCDC_PRE_W<10> {
        RB_PWR_DCDC_PRE_W::new(self)
    }
    #[doc = "Bit 15 - RWA/WZ, power plan enable, auto clear after sleep executed"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwr_plan_en(&mut self) -> RB_PWR_PLAN_EN_W<15> {
        RB_PWR_PLAN_EN_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, power plan before sleep instruction, SAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r16_power_plan](index.html) module"]
pub struct R16_POWER_PLAN_SPEC;
impl crate::RegisterSpec for R16_POWER_PLAN_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [r16_power_plan::R](R) reader structure"]
impl crate::Readable for R16_POWER_PLAN_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r16_power_plan::W](W) writer structure"]
impl crate::Writable for R16_POWER_PLAN_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R16_POWER_PLAN to value 0"]
impl crate::Resettable for R16_POWER_PLAN_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
