#[doc = "Register `R8_ADC_CFG` reader"]
pub struct R(crate::R<R8_ADC_CFG_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_ADC_CFG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_ADC_CFG_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_ADC_CFG_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_ADC_CFG` writer"]
pub struct W(crate::W<R8_ADC_CFG_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_ADC_CFG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_ADC_CFG_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_ADC_CFG_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_ADC_POWER_ON` reader - RW, ADC power control: 0=power down, 1=power on"]
pub type RB_ADC_POWER_ON_R = crate::BitReader<bool>;
#[doc = "Field `RB_ADC_POWER_ON` writer - RW, ADC power control: 0=power down, 1=power on"]
pub type RB_ADC_POWER_ON_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_ADC_CFG_SPEC, bool, O>;
#[doc = "Field `RB_ADC_BUF_EN` reader - RW, ADC input buffer enable"]
pub type RB_ADC_BUF_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_ADC_BUF_EN` writer - RW, ADC input buffer enable"]
pub type RB_ADC_BUF_EN_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_ADC_CFG_SPEC, bool, O>;
#[doc = "Field `RB_ADC_DIFF_EN` reader - RW, ADC input channel mode: 0=single-end, 1=differnetial"]
pub type RB_ADC_DIFF_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_ADC_DIFF_EN` writer - RW, ADC input channel mode: 0=single-end, 1=differnetial"]
pub type RB_ADC_DIFF_EN_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_ADC_CFG_SPEC, bool, O>;
#[doc = "Field `RB_ADC_OFS_TEST` reader - RW, enable ADC offset test mode: 0=normal mode, 1=short port4 to test offset"]
pub type RB_ADC_OFS_TEST_R = crate::BitReader<bool>;
#[doc = "Field `RB_ADC_OFS_TEST` writer - RW, enable ADC offset test mode: 0=normal mode, 1=short port4 to test offset"]
pub type RB_ADC_OFS_TEST_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_ADC_CFG_SPEC, bool, O>;
#[doc = "Field `RB_ADC_PGA_GAIN` reader - RW, set ADC input PGA gain: 00=-12dB, 01=-6dB, 10=0dB, 11=6dB"]
pub type RB_ADC_PGA_GAIN_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_ADC_PGA_GAIN` writer - RW, set ADC input PGA gain: 00=-12dB, 01=-6dB, 10=0dB, 11=6dB"]
pub type RB_ADC_PGA_GAIN_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_ADC_CFG_SPEC, u8, u8, 2, O>;
#[doc = "Field `RB_ADC_CLK_DIV` reader - RW, select ADC clock frequency: 00=3.2MHz, 01=2.67MHz, 10=5.33MHz, 11=4MHz"]
pub type RB_ADC_CLK_DIV_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_ADC_CLK_DIV` writer - RW, select ADC clock frequency: 00=3.2MHz, 01=2.67MHz, 10=5.33MHz, 11=4MHz"]
pub type RB_ADC_CLK_DIV_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_ADC_CFG_SPEC, u8, u8, 2, O>;
impl R {
    #[doc = "Bit 0 - RW, ADC power control: 0=power down, 1=power on"]
    #[inline(always)]
    pub fn rb_adc_power_on(&self) -> RB_ADC_POWER_ON_R {
        RB_ADC_POWER_ON_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - RW, ADC input buffer enable"]
    #[inline(always)]
    pub fn rb_adc_buf_en(&self) -> RB_ADC_BUF_EN_R {
        RB_ADC_BUF_EN_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - RW, ADC input channel mode: 0=single-end, 1=differnetial"]
    #[inline(always)]
    pub fn rb_adc_diff_en(&self) -> RB_ADC_DIFF_EN_R {
        RB_ADC_DIFF_EN_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - RW, enable ADC offset test mode: 0=normal mode, 1=short port4 to test offset"]
    #[inline(always)]
    pub fn rb_adc_ofs_test(&self) -> RB_ADC_OFS_TEST_R {
        RB_ADC_OFS_TEST_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bits 4:5 - RW, set ADC input PGA gain: 00=-12dB, 01=-6dB, 10=0dB, 11=6dB"]
    #[inline(always)]
    pub fn rb_adc_pga_gain(&self) -> RB_ADC_PGA_GAIN_R {
        RB_ADC_PGA_GAIN_R::new((self.bits >> 4) & 3)
    }
    #[doc = "Bits 6:7 - RW, select ADC clock frequency: 00=3.2MHz, 01=2.67MHz, 10=5.33MHz, 11=4MHz"]
    #[inline(always)]
    pub fn rb_adc_clk_div(&self) -> RB_ADC_CLK_DIV_R {
        RB_ADC_CLK_DIV_R::new((self.bits >> 6) & 3)
    }
}
impl W {
    #[doc = "Bit 0 - RW, ADC power control: 0=power down, 1=power on"]
    #[inline(always)]
    #[must_use]
    pub fn rb_adc_power_on(&mut self) -> RB_ADC_POWER_ON_W<0> {
        RB_ADC_POWER_ON_W::new(self)
    }
    #[doc = "Bit 1 - RW, ADC input buffer enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_adc_buf_en(&mut self) -> RB_ADC_BUF_EN_W<1> {
        RB_ADC_BUF_EN_W::new(self)
    }
    #[doc = "Bit 2 - RW, ADC input channel mode: 0=single-end, 1=differnetial"]
    #[inline(always)]
    #[must_use]
    pub fn rb_adc_diff_en(&mut self) -> RB_ADC_DIFF_EN_W<2> {
        RB_ADC_DIFF_EN_W::new(self)
    }
    #[doc = "Bit 3 - RW, enable ADC offset test mode: 0=normal mode, 1=short port4 to test offset"]
    #[inline(always)]
    #[must_use]
    pub fn rb_adc_ofs_test(&mut self) -> RB_ADC_OFS_TEST_W<3> {
        RB_ADC_OFS_TEST_W::new(self)
    }
    #[doc = "Bits 4:5 - RW, set ADC input PGA gain: 00=-12dB, 01=-6dB, 10=0dB, 11=6dB"]
    #[inline(always)]
    #[must_use]
    pub fn rb_adc_pga_gain(&mut self) -> RB_ADC_PGA_GAIN_W<4> {
        RB_ADC_PGA_GAIN_W::new(self)
    }
    #[doc = "Bits 6:7 - RW, select ADC clock frequency: 00=3.2MHz, 01=2.67MHz, 10=5.33MHz, 11=4MHz"]
    #[inline(always)]
    #[must_use]
    pub fn rb_adc_clk_div(&mut self) -> RB_ADC_CLK_DIV_W<6> {
        RB_ADC_CLK_DIV_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, ADC configure\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_adc_cfg](index.html) module"]
pub struct R8_ADC_CFG_SPEC;
impl crate::RegisterSpec for R8_ADC_CFG_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_adc_cfg::R](R) reader structure"]
impl crate::Readable for R8_ADC_CFG_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_adc_cfg::W](W) writer structure"]
impl crate::Writable for R8_ADC_CFG_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_ADC_CFG to value 0"]
impl crate::Resettable for R8_ADC_CFG_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
