#[doc = "Register `R8_BAT_DET_CTRL` reader"]
pub struct R(crate::R<R8_BAT_DET_CTRL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_BAT_DET_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_BAT_DET_CTRL_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_BAT_DET_CTRL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_BAT_DET_CTRL` writer"]
pub struct W(crate::W<R8_BAT_DET_CTRL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_BAT_DET_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_BAT_DET_CTRL_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_BAT_DET_CTRL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_BAT_DET_EN` reader - RWA, battery voltage detector enable"]
pub type RB_BAT_DET_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_BAT_DET_EN` writer - RWA, battery voltage detector enable"]
pub type RB_BAT_DET_EN_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_BAT_DET_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_BAT_LOWER_IE` reader - RWA, interrupt enable for battery lower voltage"]
pub type RB_BAT_LOWER_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_BAT_LOWER_IE` writer - RWA, interrupt enable for battery lower voltage"]
pub type RB_BAT_LOWER_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_BAT_DET_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_BAT_LOW_IE` reader - RWA, interrupt enable for battery low voltage"]
pub type RB_BAT_LOW_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_BAT_LOW_IE` writer - RWA, interrupt enable for battery low voltage"]
pub type RB_BAT_LOW_IE_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_BAT_DET_CTRL_SPEC, bool, O>;
impl R {
    #[doc = "Bit 0 - RWA, battery voltage detector enable"]
    #[inline(always)]
    pub fn rb_bat_det_en(&self) -> RB_BAT_DET_EN_R {
        RB_BAT_DET_EN_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 2 - RWA, interrupt enable for battery lower voltage"]
    #[inline(always)]
    pub fn rb_bat_lower_ie(&self) -> RB_BAT_LOWER_IE_R {
        RB_BAT_LOWER_IE_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - RWA, interrupt enable for battery low voltage"]
    #[inline(always)]
    pub fn rb_bat_low_ie(&self) -> RB_BAT_LOW_IE_R {
        RB_BAT_LOW_IE_R::new(((self.bits >> 3) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - RWA, battery voltage detector enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_bat_det_en(&mut self) -> RB_BAT_DET_EN_W<0> {
        RB_BAT_DET_EN_W::new(self)
    }
    #[doc = "Bit 2 - RWA, interrupt enable for battery lower voltage"]
    #[inline(always)]
    #[must_use]
    pub fn rb_bat_lower_ie(&mut self) -> RB_BAT_LOWER_IE_W<2> {
        RB_BAT_LOWER_IE_W::new(self)
    }
    #[doc = "Bit 3 - RWA, interrupt enable for battery low voltage"]
    #[inline(always)]
    #[must_use]
    pub fn rb_bat_low_ie(&mut self) -> RB_BAT_LOW_IE_W<3> {
        RB_BAT_LOW_IE_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, battery voltage detector control, SAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_bat_det_ctrl](index.html) module"]
pub struct R8_BAT_DET_CTRL_SPEC;
impl crate::RegisterSpec for R8_BAT_DET_CTRL_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_bat_det_ctrl::R](R) reader structure"]
impl crate::Readable for R8_BAT_DET_CTRL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_bat_det_ctrl::W](W) writer structure"]
impl crate::Writable for R8_BAT_DET_CTRL_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_BAT_DET_CTRL to value 0"]
impl crate::Resettable for R8_BAT_DET_CTRL_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
