#[doc = "Register `R8_CFG_FLASH` reader"]
pub struct R(crate::R<R8_CFG_FLASH_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_CFG_FLASH_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_CFG_FLASH_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_CFG_FLASH_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_CFG_FLASH` writer"]
pub struct W(crate::W<R8_CFG_FLASH_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_CFG_FLASH_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_CFG_FLASH_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_CFG_FLASH_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_CFG_FLASH_X` reader - RWA, Flash ROM configure data, keep the value unchanged if write"]
pub type RB_CFG_FLASH_X_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_CFG_FLASH_X` writer - RWA, Flash ROM configure data, keep the value unchanged if write"]
pub type RB_CFG_FLASH_X_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_CFG_FLASH_SPEC, u8, u8, 4, O>;
#[doc = "Field `RB_FLASH_BUSY_EN` reader - RWA, enable ROM busy if burst reading: 1-enable(suggest), 0-disable"]
pub type RB_FLASH_BUSY_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_FLASH_BUSY_EN` writer - RWA, enable ROM busy if burst reading: 1-enable(suggest), 0-disable"]
pub type RB_FLASH_BUSY_EN_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_CFG_FLASH_SPEC, bool, O>;
impl R {
    #[doc = "Bits 0:3 - RWA, Flash ROM configure data, keep the value unchanged if write"]
    #[inline(always)]
    pub fn rb_cfg_flash_x(&self) -> RB_CFG_FLASH_X_R {
        RB_CFG_FLASH_X_R::new(self.bits & 0x0f)
    }
    #[doc = "Bit 7 - RWA, enable ROM busy if burst reading: 1-enable(suggest), 0-disable"]
    #[inline(always)]
    pub fn rb_flash_busy_en(&self) -> RB_FLASH_BUSY_EN_R {
        RB_FLASH_BUSY_EN_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bits 0:3 - RWA, Flash ROM configure data, keep the value unchanged if write"]
    #[inline(always)]
    #[must_use]
    pub fn rb_cfg_flash_x(&mut self) -> RB_CFG_FLASH_X_W<0> {
        RB_CFG_FLASH_X_W::new(self)
    }
    #[doc = "Bit 7 - RWA, enable ROM busy if burst reading: 1-enable(suggest), 0-disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_flash_busy_en(&mut self) -> RB_FLASH_BUSY_EN_W<7> {
        RB_FLASH_BUSY_EN_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, Flash ROM configure register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_cfg_flash](index.html) module"]
pub struct R8_CFG_FLASH_SPEC;
impl crate::RegisterSpec for R8_CFG_FLASH_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_cfg_flash::R](R) reader structure"]
impl crate::Readable for R8_CFG_FLASH_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_cfg_flash::W](W) writer structure"]
impl crate::Writable for R8_CFG_FLASH_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_CFG_FLASH to value 0"]
impl crate::Resettable for R8_CFG_FLASH_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
