#[doc = "Register `R8_CK32K_CONFIG` reader"]
pub struct R(crate::R<R8_CK32K_CONFIG_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_CK32K_CONFIG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_CK32K_CONFIG_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_CK32K_CONFIG_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_CK32K_CONFIG` writer"]
pub struct W(crate::W<R8_CK32K_CONFIG_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_CK32K_CONFIG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_CK32K_CONFIG_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_CK32K_CONFIG_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_CLK_XT32K_PON` reader - RWA, external 32KHz oscillator power on"]
pub type RB_CLK_XT32K_PON_R = crate::BitReader<bool>;
#[doc = "Field `RB_CLK_XT32K_PON` writer - RWA, external 32KHz oscillator power on"]
pub type RB_CLK_XT32K_PON_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_CK32K_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_CLK_INT32K_PON` reader - RWA, internal 32KHz oscillator power on"]
pub type RB_CLK_INT32K_PON_R = crate::BitReader<bool>;
#[doc = "Field `RB_CLK_INT32K_PON` writer - RWA, internal 32KHz oscillator power on"]
pub type RB_CLK_INT32K_PON_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_CK32K_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_CLK_OSC32K_XT` reader - RWA, 32KHz oscillator source selection: 0=RC, 1=XT"]
pub type RB_CLK_OSC32K_XT_R = crate::BitReader<bool>;
#[doc = "Field `RB_CLK_OSC32K_XT` writer - RWA, 32KHz oscillator source selection: 0=RC, 1=XT"]
pub type RB_CLK_OSC32K_XT_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_CK32K_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_32K_CLK_PIN` reader - RO, 32KHz oscillator clock pin status"]
pub type RB_32K_CLK_PIN_R = crate::BitReader<bool>;
impl R {
    #[doc = "Bit 0 - RWA, external 32KHz oscillator power on"]
    #[inline(always)]
    pub fn rb_clk_xt32k_pon(&self) -> RB_CLK_XT32K_PON_R {
        RB_CLK_XT32K_PON_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - RWA, internal 32KHz oscillator power on"]
    #[inline(always)]
    pub fn rb_clk_int32k_pon(&self) -> RB_CLK_INT32K_PON_R {
        RB_CLK_INT32K_PON_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - RWA, 32KHz oscillator source selection: 0=RC, 1=XT"]
    #[inline(always)]
    pub fn rb_clk_osc32k_xt(&self) -> RB_CLK_OSC32K_XT_R {
        RB_CLK_OSC32K_XT_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 7 - RO, 32KHz oscillator clock pin status"]
    #[inline(always)]
    pub fn rb_32k_clk_pin(&self) -> RB_32K_CLK_PIN_R {
        RB_32K_CLK_PIN_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - RWA, external 32KHz oscillator power on"]
    #[inline(always)]
    #[must_use]
    pub fn rb_clk_xt32k_pon(&mut self) -> RB_CLK_XT32K_PON_W<0> {
        RB_CLK_XT32K_PON_W::new(self)
    }
    #[doc = "Bit 1 - RWA, internal 32KHz oscillator power on"]
    #[inline(always)]
    #[must_use]
    pub fn rb_clk_int32k_pon(&mut self) -> RB_CLK_INT32K_PON_W<1> {
        RB_CLK_INT32K_PON_W::new(self)
    }
    #[doc = "Bit 2 - RWA, 32KHz oscillator source selection: 0=RC, 1=XT"]
    #[inline(always)]
    #[must_use]
    pub fn rb_clk_osc32k_xt(&mut self) -> RB_CLK_OSC32K_XT_W<2> {
        RB_CLK_OSC32K_XT_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, 32KHz oscillator configure\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_ck32k_config](index.html) module"]
pub struct R8_CK32K_CONFIG_SPEC;
impl crate::RegisterSpec for R8_CK32K_CONFIG_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_ck32k_config::R](R) reader structure"]
impl crate::Readable for R8_CK32K_CONFIG_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_ck32k_config::W](W) writer structure"]
impl crate::Writable for R8_CK32K_CONFIG_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_CK32K_CONFIG to value 0"]
impl crate::Resettable for R8_CK32K_CONFIG_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
