#[doc = "Register `R8_RESET_STATUS` reader"]
pub struct R(crate::R<R8_RESET_STATUS_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_RESET_STATUS_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_RESET_STATUS_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_RESET_STATUS_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_RESET_STATUS` writer"]
pub struct W(crate::W<R8_RESET_STATUS_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_RESET_STATUS_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_RESET_STATUS_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_RESET_STATUS_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_RESET_FLAG` reader - RO, recent reset flag"]
pub type RB_RESET_FLAG_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_ROM_CODE_OFS` reader - RWA, code offset address selection in Flash ROM: 0=start address 0x000000, 1=start address 0x008000"]
pub type RB_ROM_CODE_OFS_R = crate::BitReader<bool>;
#[doc = "Field `RB_ROM_CODE_OFS` writer - RWA, code offset address selection in Flash ROM: 0=start address 0x000000, 1=start address 0x008000"]
pub type RB_ROM_CODE_OFS_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_RESET_STATUS_SPEC, bool, O>;
impl R {
    #[doc = "Bits 0:2 - RO, recent reset flag"]
    #[inline(always)]
    pub fn rb_reset_flag(&self) -> RB_RESET_FLAG_R {
        RB_RESET_FLAG_R::new(self.bits & 7)
    }
    #[doc = "Bit 4 - RWA, code offset address selection in Flash ROM: 0=start address 0x000000, 1=start address 0x008000"]
    #[inline(always)]
    pub fn rb_rom_code_ofs(&self) -> RB_ROM_CODE_OFS_R {
        RB_ROM_CODE_OFS_R::new(((self.bits >> 4) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 4 - RWA, code offset address selection in Flash ROM: 0=start address 0x000000, 1=start address 0x008000"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rom_code_ofs(&mut self) -> RB_ROM_CODE_OFS_W<4> {
        RB_ROM_CODE_OFS_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, reset status, SAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_reset_status](index.html) module"]
pub struct R8_RESET_STATUS_SPEC;
impl crate::RegisterSpec for R8_RESET_STATUS_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_reset_status::R](R) reader structure"]
impl crate::Readable for R8_RESET_STATUS_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_reset_status::W](W) writer structure"]
impl crate::Writable for R8_RESET_STATUS_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_RESET_STATUS to value 0"]
impl crate::Resettable for R8_RESET_STATUS_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
