#[doc = "Register `R8_RTC_FLAG_CTRL` reader"]
pub struct R(crate::R<R8_RTC_FLAG_CTRL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_RTC_FLAG_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_RTC_FLAG_CTRL_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_RTC_FLAG_CTRL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_RTC_FLAG_CTRL` writer"]
pub struct W(crate::W<R8_RTC_FLAG_CTRL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_RTC_FLAG_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_RTC_FLAG_CTRL_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_RTC_FLAG_CTRL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_RTC_TMR_CLR` reader - RW, set 1 to clear RTC timer action flag, auto clear"]
pub type RB_RTC_TMR_CLR_R = crate::BitReader<bool>;
#[doc = "Field `RB_RTC_TMR_CLR` writer - RW, set 1 to clear RTC timer action flag, auto clear"]
pub type RB_RTC_TMR_CLR_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_RTC_FLAG_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_RTC_TRIG_CLR` reader - RW, set 1 to clear RTC trigger action flag, auto clear"]
pub type RB_RTC_TRIG_CLR_R = crate::BitReader<bool>;
#[doc = "Field `RB_RTC_TRIG_CLR` writer - RW, set 1 to clear RTC trigger action flag, auto clear"]
pub type RB_RTC_TRIG_CLR_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_RTC_FLAG_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_RTC_TMR_FLAG` reader - RO, RTC timer action flag"]
pub type RB_RTC_TMR_FLAG_R = crate::BitReader<bool>;
#[doc = "Field `RB_RTC_TRIG_FLAG` reader - RO, RTC trigger action flag"]
pub type RB_RTC_TRIG_FLAG_R = crate::BitReader<bool>;
impl R {
    #[doc = "Bit 4 - RW, set 1 to clear RTC timer action flag, auto clear"]
    #[inline(always)]
    pub fn rb_rtc_tmr_clr(&self) -> RB_RTC_TMR_CLR_R {
        RB_RTC_TMR_CLR_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - RW, set 1 to clear RTC trigger action flag, auto clear"]
    #[inline(always)]
    pub fn rb_rtc_trig_clr(&self) -> RB_RTC_TRIG_CLR_R {
        RB_RTC_TRIG_CLR_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 6 - RO, RTC timer action flag"]
    #[inline(always)]
    pub fn rb_rtc_tmr_flag(&self) -> RB_RTC_TMR_FLAG_R {
        RB_RTC_TMR_FLAG_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - RO, RTC trigger action flag"]
    #[inline(always)]
    pub fn rb_rtc_trig_flag(&self) -> RB_RTC_TRIG_FLAG_R {
        RB_RTC_TRIG_FLAG_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 4 - RW, set 1 to clear RTC timer action flag, auto clear"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rtc_tmr_clr(&mut self) -> RB_RTC_TMR_CLR_W<4> {
        RB_RTC_TMR_CLR_W::new(self)
    }
    #[doc = "Bit 5 - RW, set 1 to clear RTC trigger action flag, auto clear"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rtc_trig_clr(&mut self) -> RB_RTC_TRIG_CLR_W<5> {
        RB_RTC_TRIG_CLR_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, RTC flag and clear control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_rtc_flag_ctrl](index.html) module"]
pub struct R8_RTC_FLAG_CTRL_SPEC;
impl crate::RegisterSpec for R8_RTC_FLAG_CTRL_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_rtc_flag_ctrl::R](R) reader structure"]
impl crate::Readable for R8_RTC_FLAG_CTRL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_rtc_flag_ctrl::W](W) writer structure"]
impl crate::Writable for R8_RTC_FLAG_CTRL_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_RTC_FLAG_CTRL to value 0"]
impl crate::Resettable for R8_RTC_FLAG_CTRL_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
