#[doc = "Register `R8_SAFE_ACCESS_SIG_RD` reader"]
pub struct R(crate::R<R8_SAFE_ACCESS_SIG_RD_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_SAFE_ACCESS_SIG_RD_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_SAFE_ACCESS_SIG_RD_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_SAFE_ACCESS_SIG_RD_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Field `RB_SAFE_ACC_MODE` reader - RO, current safe accessing mode: 11=safe/unlocked (SAM), other=locked (00..01..10..11)"]
pub type RB_SAFE_ACC_MODE_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_SAFE_ACC_ACT` reader - RO, indicate safe accessing status now: 0=locked, read only, 1=safe/unlocked (SAM), write enabled"]
pub type RB_SAFE_ACC_ACT_R = crate::BitReader<bool>;
#[doc = "Field `RB_SAFE_ACC_TIMER` reader - RO, safe accessing timer bit mask (16*clock number)"]
pub type RB_SAFE_ACC_TIMER_R = crate::FieldReader<u8, u8>;
impl R {
    #[doc = "Bits 0:1 - RO, current safe accessing mode: 11=safe/unlocked (SAM), other=locked (00..01..10..11)"]
    #[inline(always)]
    pub fn rb_safe_acc_mode(&self) -> RB_SAFE_ACC_MODE_R {
        RB_SAFE_ACC_MODE_R::new(self.bits & 3)
    }
    #[doc = "Bit 3 - RO, indicate safe accessing status now: 0=locked, read only, 1=safe/unlocked (SAM), write enabled"]
    #[inline(always)]
    pub fn rb_safe_acc_act(&self) -> RB_SAFE_ACC_ACT_R {
        RB_SAFE_ACC_ACT_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bits 4:6 - RO, safe accessing timer bit mask (16*clock number)"]
    #[inline(always)]
    pub fn rb_safe_acc_timer(&self) -> RB_SAFE_ACC_TIMER_R {
        RB_SAFE_ACC_TIMER_R::new((self.bits >> 4) & 7)
    }
}
#[doc = "R8_SAFE_ACCESS_SIG_RD Register safe accessing\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_safe_access_sig_rd](index.html) module"]
pub struct R8_SAFE_ACCESS_SIG_RD_SPEC;
impl crate::RegisterSpec for R8_SAFE_ACCESS_SIG_RD_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_safe_access_sig_rd::R](R) reader structure"]
impl crate::Readable for R8_SAFE_ACCESS_SIG_RD_SPEC {
    type Reader = R;
}
#[doc = "`reset()` method sets R8_SAFE_ACCESS_SIG_RD to value 0"]
impl crate::Resettable for R8_SAFE_ACCESS_SIG_RD_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
