#[doc = "Register `R8_SLV_CONFIG` reader"]
pub struct R(crate::R<R8_SLV_CONFIG_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_SLV_CONFIG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_SLV_CONFIG_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_SLV_CONFIG_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_SLV_CONFIG` writer"]
pub struct W(crate::W<R8_SLV_CONFIG_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_SLV_CONFIG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_SLV_CONFIG_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_SLV_CONFIG_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_SLV_ENABLE` reader - RW, parallel slave enable"]
pub type RB_SLV_ENABLE_R = crate::BitReader<bool>;
#[doc = "Field `RB_SLV_ENABLE` writer - RW, parallel slave enable"]
pub type RB_SLV_ENABLE_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_SLV_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_SLV_IE_CMD` reader - RW, enable interrupt for slave writing command event"]
pub type RB_SLV_IE_CMD_R = crate::BitReader<bool>;
#[doc = "Field `RB_SLV_IE_CMD` writer - RW, enable interrupt for slave writing command event"]
pub type RB_SLV_IE_CMD_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_SLV_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_SLV_IE_WR` reader - RW, enable interrupt for slave writing event"]
pub type RB_SLV_IE_WR_R = crate::BitReader<bool>;
#[doc = "Field `RB_SLV_IE_WR` writer - RW, enable interrupt for slave writing event"]
pub type RB_SLV_IE_WR_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_SLV_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_SLV_IE_RD` reader - RW, enable interrupt for slave reading event"]
pub type RB_SLV_IE_RD_R = crate::BitReader<bool>;
#[doc = "Field `RB_SLV_IE_RD` writer - RW, enable interrupt for slave reading event"]
pub type RB_SLV_IE_RD_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_SLV_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_IF_SLV_CMD` reader - RO, parallel slave command synchronous flag"]
pub type RB_IF_SLV_CMD_R = crate::BitReader<bool>;
#[doc = "Field `RB_IF_SLV_WR` reader - RW1, interrupt flag of parallel slave writing event"]
pub type RB_IF_SLV_WR_R = crate::BitReader<bool>;
#[doc = "Field `RB_IF_SLV_WR` writer - RW1, interrupt flag of parallel slave writing event"]
pub type RB_IF_SLV_WR_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_SLV_CONFIG_SPEC, bool, O>;
#[doc = "Field `RB_IF_SLV_RD` reader - RW1, interrupt flag of parallel slave reading event"]
pub type RB_IF_SLV_RD_R = crate::BitReader<bool>;
#[doc = "Field `RB_IF_SLV_RD` writer - RW1, interrupt flag of parallel slave reading event"]
pub type RB_IF_SLV_RD_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_SLV_CONFIG_SPEC, bool, O>;
impl R {
    #[doc = "Bit 0 - RW, parallel slave enable"]
    #[inline(always)]
    pub fn rb_slv_enable(&self) -> RB_SLV_ENABLE_R {
        RB_SLV_ENABLE_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - RW, enable interrupt for slave writing command event"]
    #[inline(always)]
    pub fn rb_slv_ie_cmd(&self) -> RB_SLV_IE_CMD_R {
        RB_SLV_IE_CMD_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - RW, enable interrupt for slave writing event"]
    #[inline(always)]
    pub fn rb_slv_ie_wr(&self) -> RB_SLV_IE_WR_R {
        RB_SLV_IE_WR_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - RW, enable interrupt for slave reading event"]
    #[inline(always)]
    pub fn rb_slv_ie_rd(&self) -> RB_SLV_IE_RD_R {
        RB_SLV_IE_RD_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 5 - RO, parallel slave command synchronous flag"]
    #[inline(always)]
    pub fn rb_if_slv_cmd(&self) -> RB_IF_SLV_CMD_R {
        RB_IF_SLV_CMD_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 6 - RW1, interrupt flag of parallel slave writing event"]
    #[inline(always)]
    pub fn rb_if_slv_wr(&self) -> RB_IF_SLV_WR_R {
        RB_IF_SLV_WR_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - RW1, interrupt flag of parallel slave reading event"]
    #[inline(always)]
    pub fn rb_if_slv_rd(&self) -> RB_IF_SLV_RD_R {
        RB_IF_SLV_RD_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - RW, parallel slave enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_slv_enable(&mut self) -> RB_SLV_ENABLE_W<0> {
        RB_SLV_ENABLE_W::new(self)
    }
    #[doc = "Bit 1 - RW, enable interrupt for slave writing command event"]
    #[inline(always)]
    #[must_use]
    pub fn rb_slv_ie_cmd(&mut self) -> RB_SLV_IE_CMD_W<1> {
        RB_SLV_IE_CMD_W::new(self)
    }
    #[doc = "Bit 2 - RW, enable interrupt for slave writing event"]
    #[inline(always)]
    #[must_use]
    pub fn rb_slv_ie_wr(&mut self) -> RB_SLV_IE_WR_W<2> {
        RB_SLV_IE_WR_W::new(self)
    }
    #[doc = "Bit 3 - RW, enable interrupt for slave reading event"]
    #[inline(always)]
    #[must_use]
    pub fn rb_slv_ie_rd(&mut self) -> RB_SLV_IE_RD_W<3> {
        RB_SLV_IE_RD_W::new(self)
    }
    #[doc = "Bit 6 - RW1, interrupt flag of parallel slave writing event"]
    #[inline(always)]
    #[must_use]
    pub fn rb_if_slv_wr(&mut self) -> RB_IF_SLV_WR_W<6> {
        RB_IF_SLV_WR_W::new(self)
    }
    #[doc = "Bit 7 - RW1, interrupt flag of parallel slave reading event"]
    #[inline(always)]
    #[must_use]
    pub fn rb_if_slv_rd(&mut self) -> RB_IF_SLV_RD_W<7> {
        RB_IF_SLV_RD_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, parallel slave configuration\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_slv_config](index.html) module"]
pub struct R8_SLV_CONFIG_SPEC;
impl crate::RegisterSpec for R8_SLV_CONFIG_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_slv_config::R](R) reader structure"]
impl crate::Readable for R8_SLV_CONFIG_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_slv_config::W](W) writer structure"]
impl crate::Writable for R8_SLV_CONFIG_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_SLV_CONFIG to value 0"]
impl crate::Resettable for R8_SLV_CONFIG_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
