#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - RW, UART2 modem control"]
    pub r8_uart2_mcr: R8_UART2_MCR,
    #[doc = "0x01 - RW, UART2 interrupt enable"]
    pub r8_uart2_ier: R8_UART2_IER,
    #[doc = "0x02 - RW, UART2 FIFO control"]
    pub r8_uart2_fcr: R8_UART2_FCR,
    #[doc = "0x03 - RW, UART2 line control"]
    pub r8_uart2_lcr: R8_UART2_LCR,
    #[doc = "0x04 - RO, UART2 interrupt identification"]
    pub r8_uart2_iir: R8_UART2_IIR,
    #[doc = "0x05 - RO, UART2 line status"]
    pub r8_uart2_lsr: R8_UART2_LSR,
    _reserved6: [u8; 0x02],
    _reserved_6_r8_uart2: [u8; 0x01],
    _reserved7: [u8; 0x01],
    #[doc = "0x0a - RO, UART2 receiver FIFO count"]
    pub r8_uart2_rfc: R8_UART2_RFC,
    #[doc = "0x0b - RO, UART2 transmitter FIFO count"]
    pub r8_uart2_tfc: R8_UART2_TFC,
    #[doc = "0x0c - RW, UART2 divisor latch"]
    pub r16_uart2_dl: R16_UART2_DL,
    #[doc = "0x0e - RW, UART2 pre-divisor latch byte, only low 7 bit, from 1 to 0/128"]
    pub r8_uart2_div: R8_UART2_DIV,
}
impl RegisterBlock {
    #[doc = "0x08 - WO, UART2 transmitter holding, transmittal byte"]
    #[inline(always)]
    pub const fn r8_uart2_thr(&self) -> &R8_UART2_THR {
        unsafe { &*(self as *const Self).cast::<u8>().add(8usize).cast() }
    }
    #[doc = "0x08 - RO, UART2 receiver buffer, receiving byte"]
    #[inline(always)]
    pub const fn r8_uart2_rbr(&self) -> &R8_UART2_RBR {
        unsafe { &*(self as *const Self).cast::<u8>().add(8usize).cast() }
    }
}
#[doc = "R8_UART2_MCR (rw) register accessor: an alias for `Reg<R8_UART2_MCR_SPEC>`"]
pub type R8_UART2_MCR = crate::Reg<r8_uart2_mcr::R8_UART2_MCR_SPEC>;
#[doc = "RW, UART2 modem control"]
pub mod r8_uart2_mcr;
#[doc = "R8_UART2_IER (rw) register accessor: an alias for `Reg<R8_UART2_IER_SPEC>`"]
pub type R8_UART2_IER = crate::Reg<r8_uart2_ier::R8_UART2_IER_SPEC>;
#[doc = "RW, UART2 interrupt enable"]
pub mod r8_uart2_ier;
#[doc = "R8_UART2_FCR (rw) register accessor: an alias for `Reg<R8_UART2_FCR_SPEC>`"]
pub type R8_UART2_FCR = crate::Reg<r8_uart2_fcr::R8_UART2_FCR_SPEC>;
#[doc = "RW, UART2 FIFO control"]
pub mod r8_uart2_fcr;
#[doc = "R8_UART2_LCR (rw) register accessor: an alias for `Reg<R8_UART2_LCR_SPEC>`"]
pub type R8_UART2_LCR = crate::Reg<r8_uart2_lcr::R8_UART2_LCR_SPEC>;
#[doc = "RW, UART2 line control"]
pub mod r8_uart2_lcr;
#[doc = "R8_UART2_IIR (r) register accessor: an alias for `Reg<R8_UART2_IIR_SPEC>`"]
pub type R8_UART2_IIR = crate::Reg<r8_uart2_iir::R8_UART2_IIR_SPEC>;
#[doc = "RO, UART2 interrupt identification"]
pub mod r8_uart2_iir;
#[doc = "R8_UART2_LSR (r) register accessor: an alias for `Reg<R8_UART2_LSR_SPEC>`"]
pub type R8_UART2_LSR = crate::Reg<r8_uart2_lsr::R8_UART2_LSR_SPEC>;
#[doc = "RO, UART2 line status"]
pub mod r8_uart2_lsr;
#[doc = "R8_UART2_RBR (r) register accessor: an alias for `Reg<R8_UART2_RBR_SPEC>`"]
pub type R8_UART2_RBR = crate::Reg<r8_uart2_rbr::R8_UART2_RBR_SPEC>;
#[doc = "RO, UART2 receiver buffer, receiving byte"]
pub mod r8_uart2_rbr;
#[doc = "R8_UART2_THR (w) register accessor: an alias for `Reg<R8_UART2_THR_SPEC>`"]
pub type R8_UART2_THR = crate::Reg<r8_uart2_thr::R8_UART2_THR_SPEC>;
#[doc = "WO, UART2 transmitter holding, transmittal byte"]
pub mod r8_uart2_thr;
#[doc = "R8_UART2_RFC (r) register accessor: an alias for `Reg<R8_UART2_RFC_SPEC>`"]
pub type R8_UART2_RFC = crate::Reg<r8_uart2_rfc::R8_UART2_RFC_SPEC>;
#[doc = "RO, UART2 receiver FIFO count"]
pub mod r8_uart2_rfc;
#[doc = "R8_UART2_TFC (r) register accessor: an alias for `Reg<R8_UART2_TFC_SPEC>`"]
pub type R8_UART2_TFC = crate::Reg<r8_uart2_tfc::R8_UART2_TFC_SPEC>;
#[doc = "RO, UART2 transmitter FIFO count"]
pub mod r8_uart2_tfc;
#[doc = "R16_UART2_DL (rw) register accessor: an alias for `Reg<R16_UART2_DL_SPEC>`"]
pub type R16_UART2_DL = crate::Reg<r16_uart2_dl::R16_UART2_DL_SPEC>;
#[doc = "RW, UART2 divisor latch"]
pub mod r16_uart2_dl;
#[doc = "R8_UART2_DIV (rw) register accessor: an alias for `Reg<R8_UART2_DIV_SPEC>`"]
pub type R8_UART2_DIV = crate::Reg<r8_uart2_div::R8_UART2_DIV_SPEC>;
#[doc = "RW, UART2 pre-divisor latch byte, only low 7 bit, from 1 to 0/128"]
pub mod r8_uart2_div;
