#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - RW, UART3 modem control"]
    pub r8_uart3_mcr: R8_UART3_MCR,
    #[doc = "0x01 - RW, UART3 interrupt enable"]
    pub r8_uart3_ier: R8_UART3_IER,
    #[doc = "0x02 - RW, UART3 FIFO control"]
    pub r8_uart3_fcr: R8_UART3_FCR,
    #[doc = "0x03 - RW, UART3 line control"]
    pub r8_uart3_lcr: R8_UART3_LCR,
    #[doc = "0x04 - RO, UART3 interrupt identification"]
    pub r8_uart3_iir: R8_UART3_IIR,
    #[doc = "0x05 - RO, UART3 line status"]
    pub r8_uart3_lsr: R8_UART3_LSR,
    _reserved6: [u8; 0x02],
    _reserved_6_r8_uart3: [u8; 0x01],
    _reserved7: [u8; 0x01],
    #[doc = "0x0a - RO, UART3 receiver FIFO count"]
    pub r8_uart3_rfc: R8_UART3_RFC,
    #[doc = "0x0b - RO, UART3 transmitter FIFO count"]
    pub r8_uart3_tfc: R8_UART3_TFC,
    #[doc = "0x0c - RW, UART3 divisor latch"]
    pub r16_uart3_dl: R16_UART3_DL,
    #[doc = "0x0e - RW, UART3 pre-divisor latch byte, only low 7 bit, from 1 to 0/128"]
    pub r8_uart3_div: R8_UART3_DIV,
}
impl RegisterBlock {
    #[doc = "0x08 - WO, UART3 transmitter holding, transmittal byte"]
    #[inline(always)]
    pub const fn r8_uart3_thr(&self) -> &R8_UART3_THR {
        unsafe { &*(self as *const Self).cast::<u8>().add(8usize).cast() }
    }
    #[doc = "0x08 - RO, UART3 receiver buffer, receiving byte"]
    #[inline(always)]
    pub const fn r8_uart3_rbr(&self) -> &R8_UART3_RBR {
        unsafe { &*(self as *const Self).cast::<u8>().add(8usize).cast() }
    }
}
#[doc = "R8_UART3_MCR (rw) register accessor: an alias for `Reg<R8_UART3_MCR_SPEC>`"]
pub type R8_UART3_MCR = crate::Reg<r8_uart3_mcr::R8_UART3_MCR_SPEC>;
#[doc = "RW, UART3 modem control"]
pub mod r8_uart3_mcr;
#[doc = "R8_UART3_IER (rw) register accessor: an alias for `Reg<R8_UART3_IER_SPEC>`"]
pub type R8_UART3_IER = crate::Reg<r8_uart3_ier::R8_UART3_IER_SPEC>;
#[doc = "RW, UART3 interrupt enable"]
pub mod r8_uart3_ier;
#[doc = "R8_UART3_FCR (rw) register accessor: an alias for `Reg<R8_UART3_FCR_SPEC>`"]
pub type R8_UART3_FCR = crate::Reg<r8_uart3_fcr::R8_UART3_FCR_SPEC>;
#[doc = "RW, UART3 FIFO control"]
pub mod r8_uart3_fcr;
#[doc = "R8_UART3_LCR (rw) register accessor: an alias for `Reg<R8_UART3_LCR_SPEC>`"]
pub type R8_UART3_LCR = crate::Reg<r8_uart3_lcr::R8_UART3_LCR_SPEC>;
#[doc = "RW, UART3 line control"]
pub mod r8_uart3_lcr;
#[doc = "R8_UART3_IIR (r) register accessor: an alias for `Reg<R8_UART3_IIR_SPEC>`"]
pub type R8_UART3_IIR = crate::Reg<r8_uart3_iir::R8_UART3_IIR_SPEC>;
#[doc = "RO, UART3 interrupt identification"]
pub mod r8_uart3_iir;
#[doc = "R8_UART3_LSR (r) register accessor: an alias for `Reg<R8_UART3_LSR_SPEC>`"]
pub type R8_UART3_LSR = crate::Reg<r8_uart3_lsr::R8_UART3_LSR_SPEC>;
#[doc = "RO, UART3 line status"]
pub mod r8_uart3_lsr;
#[doc = "R8_UART3_RBR (r) register accessor: an alias for `Reg<R8_UART3_RBR_SPEC>`"]
pub type R8_UART3_RBR = crate::Reg<r8_uart3_rbr::R8_UART3_RBR_SPEC>;
#[doc = "RO, UART3 receiver buffer, receiving byte"]
pub mod r8_uart3_rbr;
#[doc = "R8_UART3_THR (w) register accessor: an alias for `Reg<R8_UART3_THR_SPEC>`"]
pub type R8_UART3_THR = crate::Reg<r8_uart3_thr::R8_UART3_THR_SPEC>;
#[doc = "WO, UART3 transmitter holding, transmittal byte"]
pub mod r8_uart3_thr;
#[doc = "R8_UART3_RFC (r) register accessor: an alias for `Reg<R8_UART3_RFC_SPEC>`"]
pub type R8_UART3_RFC = crate::Reg<r8_uart3_rfc::R8_UART3_RFC_SPEC>;
#[doc = "RO, UART3 receiver FIFO count"]
pub mod r8_uart3_rfc;
#[doc = "R8_UART3_TFC (r) register accessor: an alias for `Reg<R8_UART3_TFC_SPEC>`"]
pub type R8_UART3_TFC = crate::Reg<r8_uart3_tfc::R8_UART3_TFC_SPEC>;
#[doc = "RO, UART3 transmitter FIFO count"]
pub mod r8_uart3_tfc;
#[doc = "R16_UART3_DL (rw) register accessor: an alias for `Reg<R16_UART3_DL_SPEC>`"]
pub type R16_UART3_DL = crate::Reg<r16_uart3_dl::R16_UART3_DL_SPEC>;
#[doc = "RW, UART3 divisor latch"]
pub mod r16_uart3_dl;
#[doc = "R8_UART3_DIV (rw) register accessor: an alias for `Reg<R8_UART3_DIV_SPEC>`"]
pub type R8_UART3_DIV = crate::Reg<r8_uart3_div::R8_UART3_DIV_SPEC>;
#[doc = "RW, UART3 pre-divisor latch byte, only low 7 bit, from 1 to 0/128"]
pub mod r8_uart3_div;
