#[doc = "Register `R8_UEP4_CTRL` reader"]
pub struct R(crate::R<R8_UEP4_CTRL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_UEP4_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_UEP4_CTRL_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_UEP4_CTRL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_UEP4_CTRL` writer"]
pub struct W(crate::W<R8_UEP4_CTRL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_UEP4_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_UEP4_CTRL_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_UEP4_CTRL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `MASK_UEP_T_RES` reader - bit mask of handshake response type for USB endpoint X transmittal (IN)"]
pub type MASK_UEP_T_RES_R = crate::FieldReader<u8, u8>;
#[doc = "Field `MASK_UEP_T_RES` writer - bit mask of handshake response type for USB endpoint X transmittal (IN)"]
pub type MASK_UEP_T_RES_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_UEP4_CTRL_SPEC, u8, u8, 2, O>;
#[doc = "Field `MASK_UEP_R_RES` reader - bit mask of handshake response type for USB endpoint X receiving (OUT)"]
pub type MASK_UEP_R_RES_R = crate::FieldReader<u8, u8>;
#[doc = "Field `MASK_UEP_R_RES` writer - bit mask of handshake response type for USB endpoint X receiving (OUT)"]
pub type MASK_UEP_R_RES_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_UEP4_CTRL_SPEC, u8, u8, 2, O>;
#[doc = "Field `RB_UEP_AUTO_TOG` reader - enable automatic toggle after successful transfer completion on endpoint 1/2/3: 0=manual toggle, 1=automatic toggle"]
pub type RB_UEP_AUTO_TOG_R = crate::BitReader<bool>;
#[doc = "Field `RB_UEP_AUTO_TOG` writer - enable automatic toggle after successful transfer completion on endpoint 1/2/3: 0=manual toggle, 1=automatic toggle"]
pub type RB_UEP_AUTO_TOG_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_UEP4_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_UEP_T_TOG` reader - prepared data toggle flag of USB endpoint X transmittal (IN): 0=DATA0, 1=DATA1"]
pub type RB_UEP_T_TOG_R = crate::BitReader<bool>;
#[doc = "Field `RB_UEP_T_TOG` writer - prepared data toggle flag of USB endpoint X transmittal (IN): 0=DATA0, 1=DATA1"]
pub type RB_UEP_T_TOG_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_UEP4_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_UEP_R_TOG` reader - expected data toggle flag of USB endpoint X receiving (OUT): 0=DATA0, 1=DATA1"]
pub type RB_UEP_R_TOG_R = crate::BitReader<bool>;
#[doc = "Field `RB_UEP_R_TOG` writer - expected data toggle flag of USB endpoint X receiving (OUT): 0=DATA0, 1=DATA1"]
pub type RB_UEP_R_TOG_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_UEP4_CTRL_SPEC, bool, O>;
impl R {
    #[doc = "Bits 0:1 - bit mask of handshake response type for USB endpoint X transmittal (IN)"]
    #[inline(always)]
    pub fn mask_uep_t_res(&self) -> MASK_UEP_T_RES_R {
        MASK_UEP_T_RES_R::new(self.bits & 3)
    }
    #[doc = "Bits 2:3 - bit mask of handshake response type for USB endpoint X receiving (OUT)"]
    #[inline(always)]
    pub fn mask_uep_r_res(&self) -> MASK_UEP_R_RES_R {
        MASK_UEP_R_RES_R::new((self.bits >> 2) & 3)
    }
    #[doc = "Bit 4 - enable automatic toggle after successful transfer completion on endpoint 1/2/3: 0=manual toggle, 1=automatic toggle"]
    #[inline(always)]
    pub fn rb_uep_auto_tog(&self) -> RB_UEP_AUTO_TOG_R {
        RB_UEP_AUTO_TOG_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 6 - prepared data toggle flag of USB endpoint X transmittal (IN): 0=DATA0, 1=DATA1"]
    #[inline(always)]
    pub fn rb_uep_t_tog(&self) -> RB_UEP_T_TOG_R {
        RB_UEP_T_TOG_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - expected data toggle flag of USB endpoint X receiving (OUT): 0=DATA0, 1=DATA1"]
    #[inline(always)]
    pub fn rb_uep_r_tog(&self) -> RB_UEP_R_TOG_R {
        RB_UEP_R_TOG_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bits 0:1 - bit mask of handshake response type for USB endpoint X transmittal (IN)"]
    #[inline(always)]
    #[must_use]
    pub fn mask_uep_t_res(&mut self) -> MASK_UEP_T_RES_W<0> {
        MASK_UEP_T_RES_W::new(self)
    }
    #[doc = "Bits 2:3 - bit mask of handshake response type for USB endpoint X receiving (OUT)"]
    #[inline(always)]
    #[must_use]
    pub fn mask_uep_r_res(&mut self) -> MASK_UEP_R_RES_W<2> {
        MASK_UEP_R_RES_W::new(self)
    }
    #[doc = "Bit 4 - enable automatic toggle after successful transfer completion on endpoint 1/2/3: 0=manual toggle, 1=automatic toggle"]
    #[inline(always)]
    #[must_use]
    pub fn rb_uep_auto_tog(&mut self) -> RB_UEP_AUTO_TOG_W<4> {
        RB_UEP_AUTO_TOG_W::new(self)
    }
    #[doc = "Bit 6 - prepared data toggle flag of USB endpoint X transmittal (IN): 0=DATA0, 1=DATA1"]
    #[inline(always)]
    #[must_use]
    pub fn rb_uep_t_tog(&mut self) -> RB_UEP_T_TOG_W<6> {
        RB_UEP_T_TOG_W::new(self)
    }
    #[doc = "Bit 7 - expected data toggle flag of USB endpoint X receiving (OUT): 0=DATA0, 1=DATA1"]
    #[inline(always)]
    #[must_use]
    pub fn rb_uep_r_tog(&mut self) -> RB_UEP_R_TOG_W<7> {
        RB_UEP_R_TOG_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "endpoint 4 control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_uep4_ctrl](index.html) module"]
pub struct R8_UEP4_CTRL_SPEC;
impl crate::RegisterSpec for R8_UEP4_CTRL_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_uep4_ctrl::R](R) reader structure"]
impl crate::Readable for R8_UEP4_CTRL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_uep4_ctrl::W](W) writer structure"]
impl crate::Writable for R8_UEP4_CTRL_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_UEP4_CTRL to value 0"]
impl crate::Resettable for R8_UEP4_CTRL_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
